#!/bin/bash
#@!  -*- buffer-read-only: t -*- vi: set ro:
#@#@#
#@#@# DO NOT EDIT THIS FILE   (melt-build-script.sh)
#@#@#
#@#@# It has been AutoGen-ed  June 15, 2013 at 09:46:47 PM by AutoGen 5.17.3
#@#@# From the definitions    melt-build-script.def
#@#@# and the template file   melt-build-script.tpl
# Generated shell script for MELT modules and MELT translator bootstrap
#   Copyright (C) 2012 - 2013  Free Software Foundation
#
# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
#@ from melt-build-script.tpl line 20 generated by Autogen 5.17.3 using melt-build-script.def

## melt-build-script.tpl generates melt-build-script.sh which may
## create meltbuild-* files and directories.  The invoking makefile
## may clean these meltbuild-* things.

## Ypu may want to set the GCCMELT_BUILD_NOTIFICATION environment variable
## to a shell script called with two arguments (a title, and a message)
## e.g. using notify-send or logger in such a script.
shopt -s nullglob




## set the overallgoal  melt-build-script.tpl:36/1 
melt_overall_goal=$1
if [ -z "$melt_overall_goal" ]; then
  melt_overall_goal=gendoc
fi

## source the builtin settings  melt-build-script.tpl:42/2 generated from the MELT runtime
. ./melt-build-settings.sh

## source the parameters  melt-build-script.tpl:45/3
. ./melt-build-param.sh

export GAWK=${GAWK:=gawk}
export MD5SUM=${MD5SUM:=md5sum}

## internal variables for this script  melt-build-script.tpl:51/4
## GCCMELT_STAGE is an internal variable; it keeps the current MELT stage
export GCCMELT_STAGE=""
## GCCMELT_BASE is an internal variable; it keeps the current MELT base
export GCCMELT_BASE=""
## GCCMELT_SKIPEMITC is an internal variable; it skips the emission of C code when non-empty
export GCCMELT_SKIPEMITC=""



date +"/*empty file for MELT build %c*/" > meltbuild-empty-file.c

[ -d meltbuild-workdir ] || mkdir  meltbuild-workdir
[ -d meltbuild-tempdir ] || mkdir  meltbuild-tempdir

## our error function  melt-build-script.tpl:66/5
function meltbuild_error () {
    echo MELT BUILD SCRIPT FAILURE: $@ >&2
    exit 1
}

## symbolic linking
function meltbuild_symlink () {
    ln -svf `realpath $1` $2
}

## our info function
function meltbuild_info () {
    echo MELT BUILD SCRIPT INFO: $@ >&2
}

## our notice function - for more important things than info
function meltbuild_notice () {
    meltnotititle=$1
    shift
    (echo; echo; echo MELT BUILD SCRIPT NOTICE "$meltnotititle:" $@ ; echo ) >&2
    if [ -n "$GCCMELT_BUILD_NOTIFICATION" ]; then
	$GCCMELT_BUILD_NOTIFICATION "$meltnotititle:" "$*"
    fi
}

## utility to build MELT specific arguments in meltbuild_emit
function meltbuild_arg () {
    local meltarg=$1
    if [ -z "$GCCMELT_IS_PLUGIN" ]; then
	echo " -fmelt-$meltarg"
    else
	echo " -fplugin-arg-melt-$meltarg"
    fi
}


if [ ! -f "$GCCMELT_RUNTIME_DEPENDENCY" ]; then
    meltbuild_error  melt-build-script.tpl:104/6 missing MELT runtime dependency "$GCCMELT_RUNTIME_DEPENDENCY" 
fi

if [ -z "$GCCMELT_CC1" ]; then
   meltbuild_error  melt-build-script.tpl:108/7 missing GCCMELT_CC1
fi

if [ ! -f meltrunsup.h ]; then 
    meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/meltrunsup.h meltrunsup.h 
    meltbuild_info  melt-build-script.tpl:113/8 symlinking meltrunsup.h header
fi

GCCMELT_RUNTIME_DEPENDENCY_MD5SUM=$($MD5SUM "$GCCMELT_RUNTIME_DEPENDENCY"  | cut -b 1-32)

case $melt_overall_goal in
    translator) ;;
    applications) ;;
    modlists) ;;
    checkruntime) ;;
    gendoc) ;;
    regenerate) ;;
    *) meltbuild_error  melt-build-script.tpl:125/9 bad MELT overall goal "$melt_overall_goal:" \
        expecting translator, applications, modlists, checkruntime or gendoc or regenerate
esac

################################################################
################ stage zero

GCCMELT_ZERO_FLAVOR=${GCCMELT_STAGE_ZERO#meltbuild-stage0-}

## The base name of the MELT translator files melt-build-script.tpl:134/10
GCCMELT_TRANSLATOR_BASE=(  warmelt-first \
  warmelt-base \
  warmelt-debug \
  warmelt-macro \
  warmelt-normal \
  warmelt-normatch \
  warmelt-genobj \
  warmelt-outobj \
  warmelt-hooks \
  warmelt-modes )

case $GCCMELT_ZERO_FLAVOR in
    optimized) ;;
    dynamic) ;;
    debugnoline) ;;
    quicklybuilt) ;;
    *) meltbuild_error  melt-build-script.tpl:142/11 bad zero flavor $GCCMELT_ZERO_FLAVOR ;;
esac


## our stage0 melt-build-script.tpl:146/12

[ -d $GCCMELT_STAGE_ZERO ] || mkdir  $GCCMELT_STAGE_ZERO


function meltbuild_do_stage_zero () {
meltbuild_notice STAGE0+  melt-build-script.tpl:152/13 starting stage zero


  meltbuild_info making stage0 warmelt-first  melt-build-script.tpl:155/14

##  stage0 melt-build-script.tpl:157/15 symlink descriptor file warmelt-first
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-first+meltdesc.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-first+meltdesc.c $GCCMELT_STAGE_ZERO/ 
  fi

##  stage0 melt-build-script.tpl:162/16 symlink melt/generated source code warmelt-first
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-first.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-first.c $GCCMELT_STAGE_ZERO/ 
      for f in $GCCMELT_MELTSOURCEDIR/generated/warmelt-first+[0-9][0-9].c ; do
	  meltbuild_symlink $f $GCCMELT_STAGE_ZERO/`basename $f`
      done
  fi

##  stage0 melt-build-script.tpl:170/17 symlink stamp warmelt-first
  if  [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-first+melttime.h" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-first+melttime.h $GCCMELT_STAGE_ZERO/warmelt-first+melttime.h 
  fi

  MELT_ZERO_GENERATED_FIRST_CUMULMD5=$($GAWK -F\" '/extern/{next} /melt_cumulated_hexmd5/{print $2}' $GCCMELT_MELTSOURCEDIR/generated/warmelt-first+meltdesc.c)


## manually generate the stage0 warmelt-first+meltbuild.mk file  melt-build-script.tpl:178/18
  MELT_ZERO_GENERATED_FIRST_BUILDMK=$GCCMELT_STAGE_ZERO/warmelt-first+meltbuild.mk

  date +"# file $MELT_ZERO_GENERATED_FIRST_BUILDMK script-generated %c" > $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  echo "# generated " melt-build-script.tpl:182/19 >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  echo "MELTGEN_MODULENAME=$GCCMELT_STAGE_ZERO/warmelt-first"  >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  echo "MELTGEN_MODULEIDENT=melt_stage_zero_FIRST"  >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$

  echo '# zerostage objects of warmelt-first melt-build-script.tpl:186/20' >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-first.$MELT_ZERO_GENERATED_FIRST_CUMULMD5.descriptor.meltpic.o: $GCCMELT_STAGE_ZERO/warmelt-first+meltdesc.c  >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-first.c $GCCMELT_STAGE_ZERO/warmelt-first+[0-9][0-9].c; do
      echo >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
      echo $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o: $f >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  done

  echo >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  echo '# zerostage module of warmelt-first melt-build-script.tpl:194/21'  >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-first.meltmod-$MELT_ZERO_GENERATED_FIRST_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so: \\  >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  echo " " $GCCMELT_STAGE_ZERO/warmelt-first.$MELT_ZERO_GENERATED_FIRST_CUMULMD5.descriptor.meltpic.o \\  >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-first+[0-9][0-9].c; do
      echo " " $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o \\ >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  done
  echo " " $GCCMELT_STAGE_ZERO/warmelt-first._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  echo >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  echo MELTGENMOD_CUMULATED_MD5SUM_melt_stage_zero_FIRST=$MELT_ZERO_GENERATED_FIRST_CUMULMD5 >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  echo MELTGENMOD_NAKED_NAME_melt_stage_zero_FIRST=warmelt-first  >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
  echo '#end of generated file ' $MELT_ZERO_GENERATED_FIRST_BUILDMK >> $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$
##
  mv $MELT_ZERO_GENERATED_FIRST_BUILDMK-tmp$$ $MELT_ZERO_GENERATED_FIRST_BUILDMK
  meltbuild_info melt-build-script.tpl:207/22 generated stagezero makedep $MELT_ZERO_GENERATED_FIRST_BUILDMK
  ls -l $MELT_ZERO_GENERATED_FIRST_BUILDMK >&2

  $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
      GCCMELT_FROM=stagezero-melt-build-script.tpl:211/23 \
      GCCMELT_COMPILER="$GCCMELT_COMPILER" \
      GCCMELTGEN_BUILD=$GCCMELT_STAGE_ZERO/ \
      GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
      GCCMELT_MODULE_FLAVOR=$GCCMELT_ZERO_FLAVOR \
      GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
      GCCMELT_MODULE_SOURCEBASE=$GCCMELT_STAGE_ZERO/warmelt-first \
      GCCMELT_CUMULATED_MD5=$MELT_ZERO_GENERATED_FIRST_CUMULMD5 \
      GCCMELT_MODULE_BINARYBASE=$GCCMELT_STAGE_ZERO/warmelt-first \
      GCCMELT_MODULE_DEPENDENCIES="$GCCMELT_CC1_DEPENDENCIES" \
      || meltbuild_error  melt-build-script.tpl:221/24 stage0 warmelt-first did not build "(with $GCCMELT_MAKE  -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER cflags $GCCMELT_COMPILER_FLAGS

  meltbuild_info melt-build-script.tpl:223/25 stage0 warmelt-first module 
  ls -l "$GCCMELT_STAGE_ZERO/warmelt-first.meltmod-$MELT_ZERO_GENERATED_FIRST_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so" >&2 \
      || meltbuild_error  melt-build-script.tpl:225/26 stage0 warmelt-first fail to build \
      "$GCCMELT_STAGE_ZERO/warmelt-first.meltmod-$MELT_ZERO_GENERATED_FIRST_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so"

  meltbuild_info melt-build-script.tpl:228/27 successfully build stage0 warmelt-first
# end stage0  melt-build-script.tpl:229/28 base  warmelt-first

  meltbuild_info making stage0 warmelt-base  melt-build-script.tpl:155/29

##  stage0 melt-build-script.tpl:157/30 symlink descriptor file warmelt-base
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-base+meltdesc.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-base+meltdesc.c $GCCMELT_STAGE_ZERO/ 
  fi

##  stage0 melt-build-script.tpl:162/31 symlink melt/generated source code warmelt-base
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-base.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-base.c $GCCMELT_STAGE_ZERO/ 
      for f in $GCCMELT_MELTSOURCEDIR/generated/warmelt-base+[0-9][0-9].c ; do
	  meltbuild_symlink $f $GCCMELT_STAGE_ZERO/`basename $f`
      done
  fi

##  stage0 melt-build-script.tpl:170/32 symlink stamp warmelt-base
  if  [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-base+melttime.h" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-base+melttime.h $GCCMELT_STAGE_ZERO/warmelt-base+melttime.h 
  fi

  MELT_ZERO_GENERATED_BASE_CUMULMD5=$($GAWK -F\" '/extern/{next} /melt_cumulated_hexmd5/{print $2}' $GCCMELT_MELTSOURCEDIR/generated/warmelt-base+meltdesc.c)


## manually generate the stage0 warmelt-base+meltbuild.mk file  melt-build-script.tpl:178/33
  MELT_ZERO_GENERATED_BASE_BUILDMK=$GCCMELT_STAGE_ZERO/warmelt-base+meltbuild.mk

  date +"# file $MELT_ZERO_GENERATED_BASE_BUILDMK script-generated %c" > $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  echo "# generated " melt-build-script.tpl:182/34 >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  echo "MELTGEN_MODULENAME=$GCCMELT_STAGE_ZERO/warmelt-base"  >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  echo "MELTGEN_MODULEIDENT=melt_stage_zero_BASE"  >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$

  echo '# zerostage objects of warmelt-base melt-build-script.tpl:186/35' >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-base.$MELT_ZERO_GENERATED_BASE_CUMULMD5.descriptor.meltpic.o: $GCCMELT_STAGE_ZERO/warmelt-base+meltdesc.c  >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-base.c $GCCMELT_STAGE_ZERO/warmelt-base+[0-9][0-9].c; do
      echo >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
      echo $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o: $f >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  done

  echo >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  echo '# zerostage module of warmelt-base melt-build-script.tpl:194/36'  >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-base.meltmod-$MELT_ZERO_GENERATED_BASE_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so: \\  >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  echo " " $GCCMELT_STAGE_ZERO/warmelt-base.$MELT_ZERO_GENERATED_BASE_CUMULMD5.descriptor.meltpic.o \\  >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-base+[0-9][0-9].c; do
      echo " " $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o \\ >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  done
  echo " " $GCCMELT_STAGE_ZERO/warmelt-base._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  echo >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  echo MELTGENMOD_CUMULATED_MD5SUM_melt_stage_zero_BASE=$MELT_ZERO_GENERATED_BASE_CUMULMD5 >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  echo MELTGENMOD_NAKED_NAME_melt_stage_zero_BASE=warmelt-base  >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
  echo '#end of generated file ' $MELT_ZERO_GENERATED_BASE_BUILDMK >> $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$
##
  mv $MELT_ZERO_GENERATED_BASE_BUILDMK-tmp$$ $MELT_ZERO_GENERATED_BASE_BUILDMK
  meltbuild_info melt-build-script.tpl:207/37 generated stagezero makedep $MELT_ZERO_GENERATED_BASE_BUILDMK
  ls -l $MELT_ZERO_GENERATED_BASE_BUILDMK >&2

  $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
      GCCMELT_FROM=stagezero-melt-build-script.tpl:211/38 \
      GCCMELT_COMPILER="$GCCMELT_COMPILER" \
      GCCMELTGEN_BUILD=$GCCMELT_STAGE_ZERO/ \
      GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
      GCCMELT_MODULE_FLAVOR=$GCCMELT_ZERO_FLAVOR \
      GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
      GCCMELT_MODULE_SOURCEBASE=$GCCMELT_STAGE_ZERO/warmelt-base \
      GCCMELT_CUMULATED_MD5=$MELT_ZERO_GENERATED_BASE_CUMULMD5 \
      GCCMELT_MODULE_BINARYBASE=$GCCMELT_STAGE_ZERO/warmelt-base \
      GCCMELT_MODULE_DEPENDENCIES="$GCCMELT_CC1_DEPENDENCIES" \
      || meltbuild_error  melt-build-script.tpl:221/39 stage0 warmelt-base did not build "(with $GCCMELT_MAKE  -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER cflags $GCCMELT_COMPILER_FLAGS

  meltbuild_info melt-build-script.tpl:223/40 stage0 warmelt-base module 
  ls -l "$GCCMELT_STAGE_ZERO/warmelt-base.meltmod-$MELT_ZERO_GENERATED_BASE_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so" >&2 \
      || meltbuild_error  melt-build-script.tpl:225/41 stage0 warmelt-base fail to build \
      "$GCCMELT_STAGE_ZERO/warmelt-base.meltmod-$MELT_ZERO_GENERATED_BASE_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so"

  meltbuild_info melt-build-script.tpl:228/42 successfully build stage0 warmelt-base
# end stage0  melt-build-script.tpl:229/43 base  warmelt-base

  meltbuild_info making stage0 warmelt-debug  melt-build-script.tpl:155/44

##  stage0 melt-build-script.tpl:157/45 symlink descriptor file warmelt-debug
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-debug+meltdesc.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-debug+meltdesc.c $GCCMELT_STAGE_ZERO/ 
  fi

##  stage0 melt-build-script.tpl:162/46 symlink melt/generated source code warmelt-debug
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-debug.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-debug.c $GCCMELT_STAGE_ZERO/ 
      for f in $GCCMELT_MELTSOURCEDIR/generated/warmelt-debug+[0-9][0-9].c ; do
	  meltbuild_symlink $f $GCCMELT_STAGE_ZERO/`basename $f`
      done
  fi

##  stage0 melt-build-script.tpl:170/47 symlink stamp warmelt-debug
  if  [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-debug+melttime.h" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-debug+melttime.h $GCCMELT_STAGE_ZERO/warmelt-debug+melttime.h 
  fi

  MELT_ZERO_GENERATED_DEBUG_CUMULMD5=$($GAWK -F\" '/extern/{next} /melt_cumulated_hexmd5/{print $2}' $GCCMELT_MELTSOURCEDIR/generated/warmelt-debug+meltdesc.c)


## manually generate the stage0 warmelt-debug+meltbuild.mk file  melt-build-script.tpl:178/48
  MELT_ZERO_GENERATED_DEBUG_BUILDMK=$GCCMELT_STAGE_ZERO/warmelt-debug+meltbuild.mk

  date +"# file $MELT_ZERO_GENERATED_DEBUG_BUILDMK script-generated %c" > $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  echo "# generated " melt-build-script.tpl:182/49 >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  echo "MELTGEN_MODULENAME=$GCCMELT_STAGE_ZERO/warmelt-debug"  >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  echo "MELTGEN_MODULEIDENT=melt_stage_zero_DEBUG"  >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$

  echo '# zerostage objects of warmelt-debug melt-build-script.tpl:186/50' >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-debug.$MELT_ZERO_GENERATED_DEBUG_CUMULMD5.descriptor.meltpic.o: $GCCMELT_STAGE_ZERO/warmelt-debug+meltdesc.c  >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-debug.c $GCCMELT_STAGE_ZERO/warmelt-debug+[0-9][0-9].c; do
      echo >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
      echo $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o: $f >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  done

  echo >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  echo '# zerostage module of warmelt-debug melt-build-script.tpl:194/51'  >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-debug.meltmod-$MELT_ZERO_GENERATED_DEBUG_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so: \\  >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  echo " " $GCCMELT_STAGE_ZERO/warmelt-debug.$MELT_ZERO_GENERATED_DEBUG_CUMULMD5.descriptor.meltpic.o \\  >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-debug+[0-9][0-9].c; do
      echo " " $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o \\ >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  done
  echo " " $GCCMELT_STAGE_ZERO/warmelt-debug._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  echo >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  echo MELTGENMOD_CUMULATED_MD5SUM_melt_stage_zero_DEBUG=$MELT_ZERO_GENERATED_DEBUG_CUMULMD5 >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  echo MELTGENMOD_NAKED_NAME_melt_stage_zero_DEBUG=warmelt-debug  >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
  echo '#end of generated file ' $MELT_ZERO_GENERATED_DEBUG_BUILDMK >> $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$
##
  mv $MELT_ZERO_GENERATED_DEBUG_BUILDMK-tmp$$ $MELT_ZERO_GENERATED_DEBUG_BUILDMK
  meltbuild_info melt-build-script.tpl:207/52 generated stagezero makedep $MELT_ZERO_GENERATED_DEBUG_BUILDMK
  ls -l $MELT_ZERO_GENERATED_DEBUG_BUILDMK >&2

  $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
      GCCMELT_FROM=stagezero-melt-build-script.tpl:211/53 \
      GCCMELT_COMPILER="$GCCMELT_COMPILER" \
      GCCMELTGEN_BUILD=$GCCMELT_STAGE_ZERO/ \
      GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
      GCCMELT_MODULE_FLAVOR=$GCCMELT_ZERO_FLAVOR \
      GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
      GCCMELT_MODULE_SOURCEBASE=$GCCMELT_STAGE_ZERO/warmelt-debug \
      GCCMELT_CUMULATED_MD5=$MELT_ZERO_GENERATED_DEBUG_CUMULMD5 \
      GCCMELT_MODULE_BINARYBASE=$GCCMELT_STAGE_ZERO/warmelt-debug \
      GCCMELT_MODULE_DEPENDENCIES="$GCCMELT_CC1_DEPENDENCIES" \
      || meltbuild_error  melt-build-script.tpl:221/54 stage0 warmelt-debug did not build "(with $GCCMELT_MAKE  -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER cflags $GCCMELT_COMPILER_FLAGS

  meltbuild_info melt-build-script.tpl:223/55 stage0 warmelt-debug module 
  ls -l "$GCCMELT_STAGE_ZERO/warmelt-debug.meltmod-$MELT_ZERO_GENERATED_DEBUG_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so" >&2 \
      || meltbuild_error  melt-build-script.tpl:225/56 stage0 warmelt-debug fail to build \
      "$GCCMELT_STAGE_ZERO/warmelt-debug.meltmod-$MELT_ZERO_GENERATED_DEBUG_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so"

  meltbuild_info melt-build-script.tpl:228/57 successfully build stage0 warmelt-debug
# end stage0  melt-build-script.tpl:229/58 base  warmelt-debug

  meltbuild_info making stage0 warmelt-macro  melt-build-script.tpl:155/59

##  stage0 melt-build-script.tpl:157/60 symlink descriptor file warmelt-macro
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-macro+meltdesc.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-macro+meltdesc.c $GCCMELT_STAGE_ZERO/ 
  fi

##  stage0 melt-build-script.tpl:162/61 symlink melt/generated source code warmelt-macro
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-macro.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-macro.c $GCCMELT_STAGE_ZERO/ 
      for f in $GCCMELT_MELTSOURCEDIR/generated/warmelt-macro+[0-9][0-9].c ; do
	  meltbuild_symlink $f $GCCMELT_STAGE_ZERO/`basename $f`
      done
  fi

##  stage0 melt-build-script.tpl:170/62 symlink stamp warmelt-macro
  if  [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-macro+melttime.h" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-macro+melttime.h $GCCMELT_STAGE_ZERO/warmelt-macro+melttime.h 
  fi

  MELT_ZERO_GENERATED_MACRO_CUMULMD5=$($GAWK -F\" '/extern/{next} /melt_cumulated_hexmd5/{print $2}' $GCCMELT_MELTSOURCEDIR/generated/warmelt-macro+meltdesc.c)


## manually generate the stage0 warmelt-macro+meltbuild.mk file  melt-build-script.tpl:178/63
  MELT_ZERO_GENERATED_MACRO_BUILDMK=$GCCMELT_STAGE_ZERO/warmelt-macro+meltbuild.mk

  date +"# file $MELT_ZERO_GENERATED_MACRO_BUILDMK script-generated %c" > $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  echo "# generated " melt-build-script.tpl:182/64 >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  echo "MELTGEN_MODULENAME=$GCCMELT_STAGE_ZERO/warmelt-macro"  >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  echo "MELTGEN_MODULEIDENT=melt_stage_zero_MACRO"  >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$

  echo '# zerostage objects of warmelt-macro melt-build-script.tpl:186/65' >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-macro.$MELT_ZERO_GENERATED_MACRO_CUMULMD5.descriptor.meltpic.o: $GCCMELT_STAGE_ZERO/warmelt-macro+meltdesc.c  >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-macro.c $GCCMELT_STAGE_ZERO/warmelt-macro+[0-9][0-9].c; do
      echo >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
      echo $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o: $f >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  done

  echo >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  echo '# zerostage module of warmelt-macro melt-build-script.tpl:194/66'  >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-macro.meltmod-$MELT_ZERO_GENERATED_MACRO_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so: \\  >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  echo " " $GCCMELT_STAGE_ZERO/warmelt-macro.$MELT_ZERO_GENERATED_MACRO_CUMULMD5.descriptor.meltpic.o \\  >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-macro+[0-9][0-9].c; do
      echo " " $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o \\ >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  done
  echo " " $GCCMELT_STAGE_ZERO/warmelt-macro._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  echo >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  echo MELTGENMOD_CUMULATED_MD5SUM_melt_stage_zero_MACRO=$MELT_ZERO_GENERATED_MACRO_CUMULMD5 >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  echo MELTGENMOD_NAKED_NAME_melt_stage_zero_MACRO=warmelt-macro  >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
  echo '#end of generated file ' $MELT_ZERO_GENERATED_MACRO_BUILDMK >> $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$
##
  mv $MELT_ZERO_GENERATED_MACRO_BUILDMK-tmp$$ $MELT_ZERO_GENERATED_MACRO_BUILDMK
  meltbuild_info melt-build-script.tpl:207/67 generated stagezero makedep $MELT_ZERO_GENERATED_MACRO_BUILDMK
  ls -l $MELT_ZERO_GENERATED_MACRO_BUILDMK >&2

  $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
      GCCMELT_FROM=stagezero-melt-build-script.tpl:211/68 \
      GCCMELT_COMPILER="$GCCMELT_COMPILER" \
      GCCMELTGEN_BUILD=$GCCMELT_STAGE_ZERO/ \
      GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
      GCCMELT_MODULE_FLAVOR=$GCCMELT_ZERO_FLAVOR \
      GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
      GCCMELT_MODULE_SOURCEBASE=$GCCMELT_STAGE_ZERO/warmelt-macro \
      GCCMELT_CUMULATED_MD5=$MELT_ZERO_GENERATED_MACRO_CUMULMD5 \
      GCCMELT_MODULE_BINARYBASE=$GCCMELT_STAGE_ZERO/warmelt-macro \
      GCCMELT_MODULE_DEPENDENCIES="$GCCMELT_CC1_DEPENDENCIES" \
      || meltbuild_error  melt-build-script.tpl:221/69 stage0 warmelt-macro did not build "(with $GCCMELT_MAKE  -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER cflags $GCCMELT_COMPILER_FLAGS

  meltbuild_info melt-build-script.tpl:223/70 stage0 warmelt-macro module 
  ls -l "$GCCMELT_STAGE_ZERO/warmelt-macro.meltmod-$MELT_ZERO_GENERATED_MACRO_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so" >&2 \
      || meltbuild_error  melt-build-script.tpl:225/71 stage0 warmelt-macro fail to build \
      "$GCCMELT_STAGE_ZERO/warmelt-macro.meltmod-$MELT_ZERO_GENERATED_MACRO_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so"

  meltbuild_info melt-build-script.tpl:228/72 successfully build stage0 warmelt-macro
# end stage0  melt-build-script.tpl:229/73 base  warmelt-macro

  meltbuild_info making stage0 warmelt-normal  melt-build-script.tpl:155/74

##  stage0 melt-build-script.tpl:157/75 symlink descriptor file warmelt-normal
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-normal+meltdesc.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-normal+meltdesc.c $GCCMELT_STAGE_ZERO/ 
  fi

##  stage0 melt-build-script.tpl:162/76 symlink melt/generated source code warmelt-normal
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-normal.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-normal.c $GCCMELT_STAGE_ZERO/ 
      for f in $GCCMELT_MELTSOURCEDIR/generated/warmelt-normal+[0-9][0-9].c ; do
	  meltbuild_symlink $f $GCCMELT_STAGE_ZERO/`basename $f`
      done
  fi

##  stage0 melt-build-script.tpl:170/77 symlink stamp warmelt-normal
  if  [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-normal+melttime.h" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-normal+melttime.h $GCCMELT_STAGE_ZERO/warmelt-normal+melttime.h 
  fi

  MELT_ZERO_GENERATED_NORMAL_CUMULMD5=$($GAWK -F\" '/extern/{next} /melt_cumulated_hexmd5/{print $2}' $GCCMELT_MELTSOURCEDIR/generated/warmelt-normal+meltdesc.c)


## manually generate the stage0 warmelt-normal+meltbuild.mk file  melt-build-script.tpl:178/78
  MELT_ZERO_GENERATED_NORMAL_BUILDMK=$GCCMELT_STAGE_ZERO/warmelt-normal+meltbuild.mk

  date +"# file $MELT_ZERO_GENERATED_NORMAL_BUILDMK script-generated %c" > $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  echo "# generated " melt-build-script.tpl:182/79 >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  echo "MELTGEN_MODULENAME=$GCCMELT_STAGE_ZERO/warmelt-normal"  >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  echo "MELTGEN_MODULEIDENT=melt_stage_zero_NORMAL"  >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$

  echo '# zerostage objects of warmelt-normal melt-build-script.tpl:186/80' >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-normal.$MELT_ZERO_GENERATED_NORMAL_CUMULMD5.descriptor.meltpic.o: $GCCMELT_STAGE_ZERO/warmelt-normal+meltdesc.c  >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-normal.c $GCCMELT_STAGE_ZERO/warmelt-normal+[0-9][0-9].c; do
      echo >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
      echo $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o: $f >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  done

  echo >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  echo '# zerostage module of warmelt-normal melt-build-script.tpl:194/81'  >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-normal.meltmod-$MELT_ZERO_GENERATED_NORMAL_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so: \\  >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  echo " " $GCCMELT_STAGE_ZERO/warmelt-normal.$MELT_ZERO_GENERATED_NORMAL_CUMULMD5.descriptor.meltpic.o \\  >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-normal+[0-9][0-9].c; do
      echo " " $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o \\ >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  done
  echo " " $GCCMELT_STAGE_ZERO/warmelt-normal._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  echo >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  echo MELTGENMOD_CUMULATED_MD5SUM_melt_stage_zero_NORMAL=$MELT_ZERO_GENERATED_NORMAL_CUMULMD5 >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  echo MELTGENMOD_NAKED_NAME_melt_stage_zero_NORMAL=warmelt-normal  >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
  echo '#end of generated file ' $MELT_ZERO_GENERATED_NORMAL_BUILDMK >> $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$
##
  mv $MELT_ZERO_GENERATED_NORMAL_BUILDMK-tmp$$ $MELT_ZERO_GENERATED_NORMAL_BUILDMK
  meltbuild_info melt-build-script.tpl:207/82 generated stagezero makedep $MELT_ZERO_GENERATED_NORMAL_BUILDMK
  ls -l $MELT_ZERO_GENERATED_NORMAL_BUILDMK >&2

  $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
      GCCMELT_FROM=stagezero-melt-build-script.tpl:211/83 \
      GCCMELT_COMPILER="$GCCMELT_COMPILER" \
      GCCMELTGEN_BUILD=$GCCMELT_STAGE_ZERO/ \
      GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
      GCCMELT_MODULE_FLAVOR=$GCCMELT_ZERO_FLAVOR \
      GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
      GCCMELT_MODULE_SOURCEBASE=$GCCMELT_STAGE_ZERO/warmelt-normal \
      GCCMELT_CUMULATED_MD5=$MELT_ZERO_GENERATED_NORMAL_CUMULMD5 \
      GCCMELT_MODULE_BINARYBASE=$GCCMELT_STAGE_ZERO/warmelt-normal \
      GCCMELT_MODULE_DEPENDENCIES="$GCCMELT_CC1_DEPENDENCIES" \
      || meltbuild_error  melt-build-script.tpl:221/84 stage0 warmelt-normal did not build "(with $GCCMELT_MAKE  -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER cflags $GCCMELT_COMPILER_FLAGS

  meltbuild_info melt-build-script.tpl:223/85 stage0 warmelt-normal module 
  ls -l "$GCCMELT_STAGE_ZERO/warmelt-normal.meltmod-$MELT_ZERO_GENERATED_NORMAL_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so" >&2 \
      || meltbuild_error  melt-build-script.tpl:225/86 stage0 warmelt-normal fail to build \
      "$GCCMELT_STAGE_ZERO/warmelt-normal.meltmod-$MELT_ZERO_GENERATED_NORMAL_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so"

  meltbuild_info melt-build-script.tpl:228/87 successfully build stage0 warmelt-normal
# end stage0  melt-build-script.tpl:229/88 base  warmelt-normal

  meltbuild_info making stage0 warmelt-normatch  melt-build-script.tpl:155/89

##  stage0 melt-build-script.tpl:157/90 symlink descriptor file warmelt-normatch
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-normatch+meltdesc.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-normatch+meltdesc.c $GCCMELT_STAGE_ZERO/ 
  fi

##  stage0 melt-build-script.tpl:162/91 symlink melt/generated source code warmelt-normatch
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-normatch.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-normatch.c $GCCMELT_STAGE_ZERO/ 
      for f in $GCCMELT_MELTSOURCEDIR/generated/warmelt-normatch+[0-9][0-9].c ; do
	  meltbuild_symlink $f $GCCMELT_STAGE_ZERO/`basename $f`
      done
  fi

##  stage0 melt-build-script.tpl:170/92 symlink stamp warmelt-normatch
  if  [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-normatch+melttime.h" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-normatch+melttime.h $GCCMELT_STAGE_ZERO/warmelt-normatch+melttime.h 
  fi

  MELT_ZERO_GENERATED_NORMATCH_CUMULMD5=$($GAWK -F\" '/extern/{next} /melt_cumulated_hexmd5/{print $2}' $GCCMELT_MELTSOURCEDIR/generated/warmelt-normatch+meltdesc.c)


## manually generate the stage0 warmelt-normatch+meltbuild.mk file  melt-build-script.tpl:178/93
  MELT_ZERO_GENERATED_NORMATCH_BUILDMK=$GCCMELT_STAGE_ZERO/warmelt-normatch+meltbuild.mk

  date +"# file $MELT_ZERO_GENERATED_NORMATCH_BUILDMK script-generated %c" > $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  echo "# generated " melt-build-script.tpl:182/94 >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  echo "MELTGEN_MODULENAME=$GCCMELT_STAGE_ZERO/warmelt-normatch"  >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  echo "MELTGEN_MODULEIDENT=melt_stage_zero_NORMATCH"  >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$

  echo '# zerostage objects of warmelt-normatch melt-build-script.tpl:186/95' >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-normatch.$MELT_ZERO_GENERATED_NORMATCH_CUMULMD5.descriptor.meltpic.o: $GCCMELT_STAGE_ZERO/warmelt-normatch+meltdesc.c  >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-normatch.c $GCCMELT_STAGE_ZERO/warmelt-normatch+[0-9][0-9].c; do
      echo >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
      echo $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o: $f >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  done

  echo >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  echo '# zerostage module of warmelt-normatch melt-build-script.tpl:194/96'  >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-normatch.meltmod-$MELT_ZERO_GENERATED_NORMATCH_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so: \\  >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  echo " " $GCCMELT_STAGE_ZERO/warmelt-normatch.$MELT_ZERO_GENERATED_NORMATCH_CUMULMD5.descriptor.meltpic.o \\  >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-normatch+[0-9][0-9].c; do
      echo " " $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o \\ >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  done
  echo " " $GCCMELT_STAGE_ZERO/warmelt-normatch._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  echo >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  echo MELTGENMOD_CUMULATED_MD5SUM_melt_stage_zero_NORMATCH=$MELT_ZERO_GENERATED_NORMATCH_CUMULMD5 >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  echo MELTGENMOD_NAKED_NAME_melt_stage_zero_NORMATCH=warmelt-normatch  >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
  echo '#end of generated file ' $MELT_ZERO_GENERATED_NORMATCH_BUILDMK >> $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$
##
  mv $MELT_ZERO_GENERATED_NORMATCH_BUILDMK-tmp$$ $MELT_ZERO_GENERATED_NORMATCH_BUILDMK
  meltbuild_info melt-build-script.tpl:207/97 generated stagezero makedep $MELT_ZERO_GENERATED_NORMATCH_BUILDMK
  ls -l $MELT_ZERO_GENERATED_NORMATCH_BUILDMK >&2

  $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
      GCCMELT_FROM=stagezero-melt-build-script.tpl:211/98 \
      GCCMELT_COMPILER="$GCCMELT_COMPILER" \
      GCCMELTGEN_BUILD=$GCCMELT_STAGE_ZERO/ \
      GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
      GCCMELT_MODULE_FLAVOR=$GCCMELT_ZERO_FLAVOR \
      GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
      GCCMELT_MODULE_SOURCEBASE=$GCCMELT_STAGE_ZERO/warmelt-normatch \
      GCCMELT_CUMULATED_MD5=$MELT_ZERO_GENERATED_NORMATCH_CUMULMD5 \
      GCCMELT_MODULE_BINARYBASE=$GCCMELT_STAGE_ZERO/warmelt-normatch \
      GCCMELT_MODULE_DEPENDENCIES="$GCCMELT_CC1_DEPENDENCIES" \
      || meltbuild_error  melt-build-script.tpl:221/99 stage0 warmelt-normatch did not build "(with $GCCMELT_MAKE  -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER cflags $GCCMELT_COMPILER_FLAGS

  meltbuild_info melt-build-script.tpl:223/100 stage0 warmelt-normatch module 
  ls -l "$GCCMELT_STAGE_ZERO/warmelt-normatch.meltmod-$MELT_ZERO_GENERATED_NORMATCH_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so" >&2 \
      || meltbuild_error  melt-build-script.tpl:225/101 stage0 warmelt-normatch fail to build \
      "$GCCMELT_STAGE_ZERO/warmelt-normatch.meltmod-$MELT_ZERO_GENERATED_NORMATCH_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so"

  meltbuild_info melt-build-script.tpl:228/102 successfully build stage0 warmelt-normatch
# end stage0  melt-build-script.tpl:229/103 base  warmelt-normatch

  meltbuild_info making stage0 warmelt-genobj  melt-build-script.tpl:155/104

##  stage0 melt-build-script.tpl:157/105 symlink descriptor file warmelt-genobj
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-genobj+meltdesc.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-genobj+meltdesc.c $GCCMELT_STAGE_ZERO/ 
  fi

##  stage0 melt-build-script.tpl:162/106 symlink melt/generated source code warmelt-genobj
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-genobj.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-genobj.c $GCCMELT_STAGE_ZERO/ 
      for f in $GCCMELT_MELTSOURCEDIR/generated/warmelt-genobj+[0-9][0-9].c ; do
	  meltbuild_symlink $f $GCCMELT_STAGE_ZERO/`basename $f`
      done
  fi

##  stage0 melt-build-script.tpl:170/107 symlink stamp warmelt-genobj
  if  [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-genobj+melttime.h" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-genobj+melttime.h $GCCMELT_STAGE_ZERO/warmelt-genobj+melttime.h 
  fi

  MELT_ZERO_GENERATED_GENOBJ_CUMULMD5=$($GAWK -F\" '/extern/{next} /melt_cumulated_hexmd5/{print $2}' $GCCMELT_MELTSOURCEDIR/generated/warmelt-genobj+meltdesc.c)


## manually generate the stage0 warmelt-genobj+meltbuild.mk file  melt-build-script.tpl:178/108
  MELT_ZERO_GENERATED_GENOBJ_BUILDMK=$GCCMELT_STAGE_ZERO/warmelt-genobj+meltbuild.mk

  date +"# file $MELT_ZERO_GENERATED_GENOBJ_BUILDMK script-generated %c" > $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  echo "# generated " melt-build-script.tpl:182/109 >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  echo "MELTGEN_MODULENAME=$GCCMELT_STAGE_ZERO/warmelt-genobj"  >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  echo "MELTGEN_MODULEIDENT=melt_stage_zero_GENOBJ"  >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$

  echo '# zerostage objects of warmelt-genobj melt-build-script.tpl:186/110' >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-genobj.$MELT_ZERO_GENERATED_GENOBJ_CUMULMD5.descriptor.meltpic.o: $GCCMELT_STAGE_ZERO/warmelt-genobj+meltdesc.c  >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-genobj.c $GCCMELT_STAGE_ZERO/warmelt-genobj+[0-9][0-9].c; do
      echo >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
      echo $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o: $f >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  done

  echo >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  echo '# zerostage module of warmelt-genobj melt-build-script.tpl:194/111'  >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-genobj.meltmod-$MELT_ZERO_GENERATED_GENOBJ_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so: \\  >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  echo " " $GCCMELT_STAGE_ZERO/warmelt-genobj.$MELT_ZERO_GENERATED_GENOBJ_CUMULMD5.descriptor.meltpic.o \\  >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-genobj+[0-9][0-9].c; do
      echo " " $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o \\ >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  done
  echo " " $GCCMELT_STAGE_ZERO/warmelt-genobj._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  echo >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  echo MELTGENMOD_CUMULATED_MD5SUM_melt_stage_zero_GENOBJ=$MELT_ZERO_GENERATED_GENOBJ_CUMULMD5 >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  echo MELTGENMOD_NAKED_NAME_melt_stage_zero_GENOBJ=warmelt-genobj  >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
  echo '#end of generated file ' $MELT_ZERO_GENERATED_GENOBJ_BUILDMK >> $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$
##
  mv $MELT_ZERO_GENERATED_GENOBJ_BUILDMK-tmp$$ $MELT_ZERO_GENERATED_GENOBJ_BUILDMK
  meltbuild_info melt-build-script.tpl:207/112 generated stagezero makedep $MELT_ZERO_GENERATED_GENOBJ_BUILDMK
  ls -l $MELT_ZERO_GENERATED_GENOBJ_BUILDMK >&2

  $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
      GCCMELT_FROM=stagezero-melt-build-script.tpl:211/113 \
      GCCMELT_COMPILER="$GCCMELT_COMPILER" \
      GCCMELTGEN_BUILD=$GCCMELT_STAGE_ZERO/ \
      GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
      GCCMELT_MODULE_FLAVOR=$GCCMELT_ZERO_FLAVOR \
      GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
      GCCMELT_MODULE_SOURCEBASE=$GCCMELT_STAGE_ZERO/warmelt-genobj \
      GCCMELT_CUMULATED_MD5=$MELT_ZERO_GENERATED_GENOBJ_CUMULMD5 \
      GCCMELT_MODULE_BINARYBASE=$GCCMELT_STAGE_ZERO/warmelt-genobj \
      GCCMELT_MODULE_DEPENDENCIES="$GCCMELT_CC1_DEPENDENCIES" \
      || meltbuild_error  melt-build-script.tpl:221/114 stage0 warmelt-genobj did not build "(with $GCCMELT_MAKE  -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER cflags $GCCMELT_COMPILER_FLAGS

  meltbuild_info melt-build-script.tpl:223/115 stage0 warmelt-genobj module 
  ls -l "$GCCMELT_STAGE_ZERO/warmelt-genobj.meltmod-$MELT_ZERO_GENERATED_GENOBJ_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so" >&2 \
      || meltbuild_error  melt-build-script.tpl:225/116 stage0 warmelt-genobj fail to build \
      "$GCCMELT_STAGE_ZERO/warmelt-genobj.meltmod-$MELT_ZERO_GENERATED_GENOBJ_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so"

  meltbuild_info melt-build-script.tpl:228/117 successfully build stage0 warmelt-genobj
# end stage0  melt-build-script.tpl:229/118 base  warmelt-genobj

  meltbuild_info making stage0 warmelt-outobj  melt-build-script.tpl:155/119

##  stage0 melt-build-script.tpl:157/120 symlink descriptor file warmelt-outobj
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-outobj+meltdesc.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-outobj+meltdesc.c $GCCMELT_STAGE_ZERO/ 
  fi

##  stage0 melt-build-script.tpl:162/121 symlink melt/generated source code warmelt-outobj
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-outobj.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-outobj.c $GCCMELT_STAGE_ZERO/ 
      for f in $GCCMELT_MELTSOURCEDIR/generated/warmelt-outobj+[0-9][0-9].c ; do
	  meltbuild_symlink $f $GCCMELT_STAGE_ZERO/`basename $f`
      done
  fi

##  stage0 melt-build-script.tpl:170/122 symlink stamp warmelt-outobj
  if  [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-outobj+melttime.h" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-outobj+melttime.h $GCCMELT_STAGE_ZERO/warmelt-outobj+melttime.h 
  fi

  MELT_ZERO_GENERATED_OUTOBJ_CUMULMD5=$($GAWK -F\" '/extern/{next} /melt_cumulated_hexmd5/{print $2}' $GCCMELT_MELTSOURCEDIR/generated/warmelt-outobj+meltdesc.c)


## manually generate the stage0 warmelt-outobj+meltbuild.mk file  melt-build-script.tpl:178/123
  MELT_ZERO_GENERATED_OUTOBJ_BUILDMK=$GCCMELT_STAGE_ZERO/warmelt-outobj+meltbuild.mk

  date +"# file $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK script-generated %c" > $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  echo "# generated " melt-build-script.tpl:182/124 >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  echo "MELTGEN_MODULENAME=$GCCMELT_STAGE_ZERO/warmelt-outobj"  >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  echo "MELTGEN_MODULEIDENT=melt_stage_zero_OUTOBJ"  >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$

  echo '# zerostage objects of warmelt-outobj melt-build-script.tpl:186/125' >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-outobj.$MELT_ZERO_GENERATED_OUTOBJ_CUMULMD5.descriptor.meltpic.o: $GCCMELT_STAGE_ZERO/warmelt-outobj+meltdesc.c  >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-outobj.c $GCCMELT_STAGE_ZERO/warmelt-outobj+[0-9][0-9].c; do
      echo >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
      echo $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o: $f >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  done

  echo >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  echo '# zerostage module of warmelt-outobj melt-build-script.tpl:194/126'  >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-outobj.meltmod-$MELT_ZERO_GENERATED_OUTOBJ_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so: \\  >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  echo " " $GCCMELT_STAGE_ZERO/warmelt-outobj.$MELT_ZERO_GENERATED_OUTOBJ_CUMULMD5.descriptor.meltpic.o \\  >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-outobj+[0-9][0-9].c; do
      echo " " $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o \\ >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  done
  echo " " $GCCMELT_STAGE_ZERO/warmelt-outobj._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  echo >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  echo MELTGENMOD_CUMULATED_MD5SUM_melt_stage_zero_OUTOBJ=$MELT_ZERO_GENERATED_OUTOBJ_CUMULMD5 >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  echo MELTGENMOD_NAKED_NAME_melt_stage_zero_OUTOBJ=warmelt-outobj  >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
  echo '#end of generated file ' $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK >> $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$
##
  mv $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK-tmp$$ $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK
  meltbuild_info melt-build-script.tpl:207/127 generated stagezero makedep $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK
  ls -l $MELT_ZERO_GENERATED_OUTOBJ_BUILDMK >&2

  $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
      GCCMELT_FROM=stagezero-melt-build-script.tpl:211/128 \
      GCCMELT_COMPILER="$GCCMELT_COMPILER" \
      GCCMELTGEN_BUILD=$GCCMELT_STAGE_ZERO/ \
      GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
      GCCMELT_MODULE_FLAVOR=$GCCMELT_ZERO_FLAVOR \
      GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
      GCCMELT_MODULE_SOURCEBASE=$GCCMELT_STAGE_ZERO/warmelt-outobj \
      GCCMELT_CUMULATED_MD5=$MELT_ZERO_GENERATED_OUTOBJ_CUMULMD5 \
      GCCMELT_MODULE_BINARYBASE=$GCCMELT_STAGE_ZERO/warmelt-outobj \
      GCCMELT_MODULE_DEPENDENCIES="$GCCMELT_CC1_DEPENDENCIES" \
      || meltbuild_error  melt-build-script.tpl:221/129 stage0 warmelt-outobj did not build "(with $GCCMELT_MAKE  -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER cflags $GCCMELT_COMPILER_FLAGS

  meltbuild_info melt-build-script.tpl:223/130 stage0 warmelt-outobj module 
  ls -l "$GCCMELT_STAGE_ZERO/warmelt-outobj.meltmod-$MELT_ZERO_GENERATED_OUTOBJ_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so" >&2 \
      || meltbuild_error  melt-build-script.tpl:225/131 stage0 warmelt-outobj fail to build \
      "$GCCMELT_STAGE_ZERO/warmelt-outobj.meltmod-$MELT_ZERO_GENERATED_OUTOBJ_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so"

  meltbuild_info melt-build-script.tpl:228/132 successfully build stage0 warmelt-outobj
# end stage0  melt-build-script.tpl:229/133 base  warmelt-outobj

  meltbuild_info making stage0 warmelt-hooks  melt-build-script.tpl:155/134

##  stage0 melt-build-script.tpl:157/135 symlink descriptor file warmelt-hooks
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-hooks+meltdesc.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-hooks+meltdesc.c $GCCMELT_STAGE_ZERO/ 
  fi

##  stage0 melt-build-script.tpl:162/136 symlink melt/generated source code warmelt-hooks
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-hooks.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-hooks.c $GCCMELT_STAGE_ZERO/ 
      for f in $GCCMELT_MELTSOURCEDIR/generated/warmelt-hooks+[0-9][0-9].c ; do
	  meltbuild_symlink $f $GCCMELT_STAGE_ZERO/`basename $f`
      done
  fi

##  stage0 melt-build-script.tpl:170/137 symlink stamp warmelt-hooks
  if  [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-hooks+melttime.h" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-hooks+melttime.h $GCCMELT_STAGE_ZERO/warmelt-hooks+melttime.h 
  fi

  MELT_ZERO_GENERATED_HOOKS_CUMULMD5=$($GAWK -F\" '/extern/{next} /melt_cumulated_hexmd5/{print $2}' $GCCMELT_MELTSOURCEDIR/generated/warmelt-hooks+meltdesc.c)


## manually generate the stage0 warmelt-hooks+meltbuild.mk file  melt-build-script.tpl:178/138
  MELT_ZERO_GENERATED_HOOKS_BUILDMK=$GCCMELT_STAGE_ZERO/warmelt-hooks+meltbuild.mk

  date +"# file $MELT_ZERO_GENERATED_HOOKS_BUILDMK script-generated %c" > $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  echo "# generated " melt-build-script.tpl:182/139 >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  echo "MELTGEN_MODULENAME=$GCCMELT_STAGE_ZERO/warmelt-hooks"  >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  echo "MELTGEN_MODULEIDENT=melt_stage_zero_HOOKS"  >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$

  echo '# zerostage objects of warmelt-hooks melt-build-script.tpl:186/140' >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-hooks.$MELT_ZERO_GENERATED_HOOKS_CUMULMD5.descriptor.meltpic.o: $GCCMELT_STAGE_ZERO/warmelt-hooks+meltdesc.c  >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-hooks.c $GCCMELT_STAGE_ZERO/warmelt-hooks+[0-9][0-9].c; do
      echo >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
      echo $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o: $f >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  done

  echo >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  echo '# zerostage module of warmelt-hooks melt-build-script.tpl:194/141'  >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-hooks.meltmod-$MELT_ZERO_GENERATED_HOOKS_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so: \\  >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  echo " " $GCCMELT_STAGE_ZERO/warmelt-hooks.$MELT_ZERO_GENERATED_HOOKS_CUMULMD5.descriptor.meltpic.o \\  >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-hooks+[0-9][0-9].c; do
      echo " " $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o \\ >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  done
  echo " " $GCCMELT_STAGE_ZERO/warmelt-hooks._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  echo >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  echo MELTGENMOD_CUMULATED_MD5SUM_melt_stage_zero_HOOKS=$MELT_ZERO_GENERATED_HOOKS_CUMULMD5 >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  echo MELTGENMOD_NAKED_NAME_melt_stage_zero_HOOKS=warmelt-hooks  >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
  echo '#end of generated file ' $MELT_ZERO_GENERATED_HOOKS_BUILDMK >> $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$
##
  mv $MELT_ZERO_GENERATED_HOOKS_BUILDMK-tmp$$ $MELT_ZERO_GENERATED_HOOKS_BUILDMK
  meltbuild_info melt-build-script.tpl:207/142 generated stagezero makedep $MELT_ZERO_GENERATED_HOOKS_BUILDMK
  ls -l $MELT_ZERO_GENERATED_HOOKS_BUILDMK >&2

  $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
      GCCMELT_FROM=stagezero-melt-build-script.tpl:211/143 \
      GCCMELT_COMPILER="$GCCMELT_COMPILER" \
      GCCMELTGEN_BUILD=$GCCMELT_STAGE_ZERO/ \
      GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
      GCCMELT_MODULE_FLAVOR=$GCCMELT_ZERO_FLAVOR \
      GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
      GCCMELT_MODULE_SOURCEBASE=$GCCMELT_STAGE_ZERO/warmelt-hooks \
      GCCMELT_CUMULATED_MD5=$MELT_ZERO_GENERATED_HOOKS_CUMULMD5 \
      GCCMELT_MODULE_BINARYBASE=$GCCMELT_STAGE_ZERO/warmelt-hooks \
      GCCMELT_MODULE_DEPENDENCIES="$GCCMELT_CC1_DEPENDENCIES" \
      || meltbuild_error  melt-build-script.tpl:221/144 stage0 warmelt-hooks did not build "(with $GCCMELT_MAKE  -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER cflags $GCCMELT_COMPILER_FLAGS

  meltbuild_info melt-build-script.tpl:223/145 stage0 warmelt-hooks module 
  ls -l "$GCCMELT_STAGE_ZERO/warmelt-hooks.meltmod-$MELT_ZERO_GENERATED_HOOKS_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so" >&2 \
      || meltbuild_error  melt-build-script.tpl:225/146 stage0 warmelt-hooks fail to build \
      "$GCCMELT_STAGE_ZERO/warmelt-hooks.meltmod-$MELT_ZERO_GENERATED_HOOKS_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so"

  meltbuild_info melt-build-script.tpl:228/147 successfully build stage0 warmelt-hooks
# end stage0  melt-build-script.tpl:229/148 base  warmelt-hooks

  meltbuild_info making stage0 warmelt-modes  melt-build-script.tpl:155/149

##  stage0 melt-build-script.tpl:157/150 symlink descriptor file warmelt-modes
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-modes+meltdesc.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-modes+meltdesc.c $GCCMELT_STAGE_ZERO/ 
  fi

##  stage0 melt-build-script.tpl:162/151 symlink melt/generated source code warmelt-modes
  if [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-modes.c" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-modes.c $GCCMELT_STAGE_ZERO/ 
      for f in $GCCMELT_MELTSOURCEDIR/generated/warmelt-modes+[0-9][0-9].c ; do
	  meltbuild_symlink $f $GCCMELT_STAGE_ZERO/`basename $f`
      done
  fi

##  stage0 melt-build-script.tpl:170/152 symlink stamp warmelt-modes
  if  [ ! -f "$GCCMELT_STAGE_ZERO/warmelt-modes+melttime.h" ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/generated/warmelt-modes+melttime.h $GCCMELT_STAGE_ZERO/warmelt-modes+melttime.h 
  fi

  MELT_ZERO_GENERATED_MODES_CUMULMD5=$($GAWK -F\" '/extern/{next} /melt_cumulated_hexmd5/{print $2}' $GCCMELT_MELTSOURCEDIR/generated/warmelt-modes+meltdesc.c)


## manually generate the stage0 warmelt-modes+meltbuild.mk file  melt-build-script.tpl:178/153
  MELT_ZERO_GENERATED_MODES_BUILDMK=$GCCMELT_STAGE_ZERO/warmelt-modes+meltbuild.mk

  date +"# file $MELT_ZERO_GENERATED_MODES_BUILDMK script-generated %c" > $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  echo "# generated " melt-build-script.tpl:182/154 >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  echo "MELTGEN_MODULENAME=$GCCMELT_STAGE_ZERO/warmelt-modes"  >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  echo "MELTGEN_MODULEIDENT=melt_stage_zero_MODES"  >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$

  echo '# zerostage objects of warmelt-modes melt-build-script.tpl:186/155' >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-modes.$MELT_ZERO_GENERATED_MODES_CUMULMD5.descriptor.meltpic.o: $GCCMELT_STAGE_ZERO/warmelt-modes+meltdesc.c  >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-modes.c $GCCMELT_STAGE_ZERO/warmelt-modes+[0-9][0-9].c; do
      echo >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
      echo $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o: $f >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  done

  echo >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  echo '# zerostage module of warmelt-modes melt-build-script.tpl:194/156'  >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  echo $GCCMELT_STAGE_ZERO/warmelt-modes.meltmod-$MELT_ZERO_GENERATED_MODES_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so: \\  >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  echo " " $GCCMELT_STAGE_ZERO/warmelt-modes.$MELT_ZERO_GENERATED_MODES_CUMULMD5.descriptor.meltpic.o \\  >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  for f in $GCCMELT_STAGE_ZERO/warmelt-modes+[0-9][0-9].c; do
      echo " " $GCCMELT_STAGE_ZERO/`basename $f .c`._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o \\ >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  done
  echo " " $GCCMELT_STAGE_ZERO/warmelt-modes._NOMDFIVESUM_.$GCCMELT_ZERO_FLAVOR.meltpic.o >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  echo >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  echo MELTGENMOD_CUMULATED_MD5SUM_melt_stage_zero_MODES=$MELT_ZERO_GENERATED_MODES_CUMULMD5 >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  echo MELTGENMOD_NAKED_NAME_melt_stage_zero_MODES=warmelt-modes  >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
  echo '#end of generated file ' $MELT_ZERO_GENERATED_MODES_BUILDMK >> $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$
##
  mv $MELT_ZERO_GENERATED_MODES_BUILDMK-tmp$$ $MELT_ZERO_GENERATED_MODES_BUILDMK
  meltbuild_info melt-build-script.tpl:207/157 generated stagezero makedep $MELT_ZERO_GENERATED_MODES_BUILDMK
  ls -l $MELT_ZERO_GENERATED_MODES_BUILDMK >&2

  $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
      GCCMELT_FROM=stagezero-melt-build-script.tpl:211/158 \
      GCCMELT_COMPILER="$GCCMELT_COMPILER" \
      GCCMELTGEN_BUILD=$GCCMELT_STAGE_ZERO/ \
      GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
      GCCMELT_MODULE_FLAVOR=$GCCMELT_ZERO_FLAVOR \
      GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
      GCCMELT_MODULE_SOURCEBASE=$GCCMELT_STAGE_ZERO/warmelt-modes \
      GCCMELT_CUMULATED_MD5=$MELT_ZERO_GENERATED_MODES_CUMULMD5 \
      GCCMELT_MODULE_BINARYBASE=$GCCMELT_STAGE_ZERO/warmelt-modes \
      GCCMELT_MODULE_DEPENDENCIES="$GCCMELT_CC1_DEPENDENCIES" \
      || meltbuild_error  melt-build-script.tpl:221/159 stage0 warmelt-modes did not build "(with $GCCMELT_MAKE  -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER cflags $GCCMELT_COMPILER_FLAGS

  meltbuild_info melt-build-script.tpl:223/160 stage0 warmelt-modes module 
  ls -l "$GCCMELT_STAGE_ZERO/warmelt-modes.meltmod-$MELT_ZERO_GENERATED_MODES_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so" >&2 \
      || meltbuild_error  melt-build-script.tpl:225/161 stage0 warmelt-modes fail to build \
      "$GCCMELT_STAGE_ZERO/warmelt-modes.meltmod-$MELT_ZERO_GENERATED_MODES_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so"

  meltbuild_info melt-build-script.tpl:228/162 successfully build stage0 warmelt-modes
# end stage0  melt-build-script.tpl:229/163 base  warmelt-modes

} ################ end of function meltbuild_do_stage_zero melt-build-script.tpl:231/164
################################################################

## stage0 stamp file melt-build-script.tpl:234/165
melt_stagezero_stamp=$GCCMELT_STAGE_ZERO/$GCCMELT_STAGE_ZERO.stamp

## test if stage0 should be skipped then do it  melt-build-script.tpl:237/166
if [ ! -f "$melt_stagezero_stamp" -o "$melt_stagezero_stamp" -ot "$GCCMELT_RUNTIME_DEPENDENCY" ]; then
   meltbuild_do_stage_zero
    melt_stagezero_stamptemp=$melt_stagezero_stamp-tmp$$
    echo MELT stagezero stampfile $GCCMELT_STAGE_ZERO.stamp for MELT $MELTGCCBUILTIN_VERSION_STRING from melt-build-script.tpl:241/167 >  $melt_stagezero_stamptemp
    echo $GCCMELT_RUNTIME_DEPENDENCY_MD5SUM $GCCMELT_RUNTIME_DEPENDENCY >> $melt_stagezero_stamptemp

#  stagezero stamp melt-build-script.tpl:244/168 base  warmelt-first
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-first.c $GCCMELT_STAGE_ZERO/warmelt-first+[0-9][0-9].c >> $melt_stagezero_stamptemp
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-first.meltmod-$MELT_ZERO_GENERATED_FIRST_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so  >> $melt_stagezero_stamptemp

#  stagezero stamp melt-build-script.tpl:244/169 base  warmelt-base
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-base.c $GCCMELT_STAGE_ZERO/warmelt-base+[0-9][0-9].c >> $melt_stagezero_stamptemp
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-base.meltmod-$MELT_ZERO_GENERATED_BASE_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so  >> $melt_stagezero_stamptemp

#  stagezero stamp melt-build-script.tpl:244/170 base  warmelt-debug
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-debug.c $GCCMELT_STAGE_ZERO/warmelt-debug+[0-9][0-9].c >> $melt_stagezero_stamptemp
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-debug.meltmod-$MELT_ZERO_GENERATED_DEBUG_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so  >> $melt_stagezero_stamptemp

#  stagezero stamp melt-build-script.tpl:244/171 base  warmelt-macro
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-macro.c $GCCMELT_STAGE_ZERO/warmelt-macro+[0-9][0-9].c >> $melt_stagezero_stamptemp
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-macro.meltmod-$MELT_ZERO_GENERATED_MACRO_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so  >> $melt_stagezero_stamptemp

#  stagezero stamp melt-build-script.tpl:244/172 base  warmelt-normal
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-normal.c $GCCMELT_STAGE_ZERO/warmelt-normal+[0-9][0-9].c >> $melt_stagezero_stamptemp
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-normal.meltmod-$MELT_ZERO_GENERATED_NORMAL_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so  >> $melt_stagezero_stamptemp

#  stagezero stamp melt-build-script.tpl:244/173 base  warmelt-normatch
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-normatch.c $GCCMELT_STAGE_ZERO/warmelt-normatch+[0-9][0-9].c >> $melt_stagezero_stamptemp
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-normatch.meltmod-$MELT_ZERO_GENERATED_NORMATCH_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so  >> $melt_stagezero_stamptemp

#  stagezero stamp melt-build-script.tpl:244/174 base  warmelt-genobj
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-genobj.c $GCCMELT_STAGE_ZERO/warmelt-genobj+[0-9][0-9].c >> $melt_stagezero_stamptemp
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-genobj.meltmod-$MELT_ZERO_GENERATED_GENOBJ_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so  >> $melt_stagezero_stamptemp

#  stagezero stamp melt-build-script.tpl:244/175 base  warmelt-outobj
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-outobj.c $GCCMELT_STAGE_ZERO/warmelt-outobj+[0-9][0-9].c >> $melt_stagezero_stamptemp
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-outobj.meltmod-$MELT_ZERO_GENERATED_OUTOBJ_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so  >> $melt_stagezero_stamptemp

#  stagezero stamp melt-build-script.tpl:244/176 base  warmelt-hooks
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-hooks.c $GCCMELT_STAGE_ZERO/warmelt-hooks+[0-9][0-9].c >> $melt_stagezero_stamptemp
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-hooks.meltmod-$MELT_ZERO_GENERATED_HOOKS_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so  >> $melt_stagezero_stamptemp

#  stagezero stamp melt-build-script.tpl:244/177 base  warmelt-modes
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-modes.c $GCCMELT_STAGE_ZERO/warmelt-modes+[0-9][0-9].c >> $melt_stagezero_stamptemp
    $MD5SUM $GCCMELT_STAGE_ZERO/warmelt-modes.meltmod-$MELT_ZERO_GENERATED_MODES_CUMULMD5.$GCCMELT_ZERO_FLAVOR.so  >> $melt_stagezero_stamptemp

    $GCCMELT_MOVE_IF_CHANGE $melt_stagezero_stamptemp $melt_stagezero_stamp
else
   meltbuild_info melt-build-script.tpl:250/178 skipped stage0 because of stamp file $melt_stagezero_stamp
fi

meltbuild_info melt-build-script.tpl:253/179 times after stagezero at `date '+%x %H:%M:%S'`: ;  times >&2


################################################################
## function to run MELT to emit C code  melt-build-script.tpl:257/180
function meltbuild_emit () {
    local meltfrom=$1
    local meltmode=$2
    local meltbase=$3
    local meltstage=$4
    local meltprevstage=$5
    local meltinit=$6
    local meltinclude=$7
    local meltargs=$meltstage/$meltbase.args
    local meltsrc=$(realpath $GCCMELT_MELTSOURCEDIR/$meltbase.melt)
    meltbuild_info meltfrom=$meltfrom meltmode=$meltmode meltbase=$meltbase meltstage=$meltstage meltprevstage=$meltprevstage meltinit=$meltinit meltinclude=$meltinclude meltsrc=$meltsrc
    local meltsum
    local meltprevf
    if [ -z "$meltmode" ]; then
	meltbuild_error $meltfrom no MELT mode at stage $meltstage
    fi
    if [ ! -f "$meltsrc" ]; then
	meltbuild_error $meltfrom no MELT file $meltsrc at stage $meltstage base $meltbase
    fi
    if [ -z "$meltinit" ]; then
	meltbuild_error $meltfrom no MELT init  at stage $meltstage base $meltbase
    fi
    meltsum=$($MD5SUM $meltsrc | $GAWK '{print $1}')
    meltbuild_info $meltfrom emit C code for $meltbase of $meltstage
    echo -Wno-shadow -frandom-seed=$meltsum > $meltargs-$$-tmp
    ## various arguments
    echo " -DGCCMELT_FROM_ARG=\"$meltfrom\"" >>  $meltargs-$$-tmp
    meltbuild_arg mode=$meltmode >> $meltargs-$$-tmp
    meltbuild_arg arg=$meltsrc >>  $meltargs-$$-tmp
    meltbuild_arg output=$meltstage/$meltbase  >>  $meltargs-$$-tmp
    meltbuild_arg "module-make-command='$GCCMELT_MAKE'" >> $meltargs-$$-tmp
    meltbuild_arg module-makefile=$GCCMELT_MODULE_MK >> $meltargs-$$-tmp
    meltbuild_arg "module-cflags='$GCCMELT_INCLUDES -I. -I$meltstage -I$meltprevstage $GCCMELT_COMPILER_FLAGS'" >>  $meltargs-$$-tmp
    meltbuild_arg init=$meltinit >> $meltargs-$$-tmp
    meltbuild_arg workdir=meltbuild-workdir >> $meltargs-$$-tmp
    meltbuild_arg tempdir=meltbuild-tempdir >> $meltargs-$$-tmp
    meltbuild_arg source-path=$meltstage:$meltprevstage:. >> $meltargs-$$-tmp
    meltbuild_arg module-path=$meltstage:$meltprevstage:. >> $meltargs-$$-tmp
    meltbuild_arg bootstrapping  >> $meltargs-$$-tmp
    meltbuild_arg generate-work-link  >> $meltargs-$$-tmp
    meltbuild_arg generated-c-file-list=$meltstage/$meltbase.cfilist  >> $meltargs-$$-tmp
    ## final empty file
    echo meltbuild-empty-file.c >>  $meltargs-$$-tmp
    mv $meltargs-$$-tmp $meltargs
    meltbuild_info $meltfrom argument file $meltargs is
    cat  $meltargs < /dev/null >&2
    if [ -z "$GCCMELT_SKIPEMITC" ]; then
	$GCCMELT_CC1_PREFIX $GCCMELT_CC1 @$meltargs || meltbuild_error $meltfrom failed with arguments @$meltargs
        ## remove obsolete secondary C files left previously in $meltstage 
	for meltcsecfil in $meltstage/$meltbase+[0-9][0-9].c ; do
	    if grep -q `basename $meltcsecfil` "$meltstage/$meltbase.cfilist" ; then
		: # at  melt-build-script.tpl:309/181
	    else
		meltbuild_info $meltfrom removing obsolete $meltcsecfil
		rm -f "$meltcsecfil"
	    fi
	done
    else
	meltbuild_info $meltfrom skips emission of C code with  @$meltargs stage $meltstage prevstage $meltprevstage skipreason $GCCMELT_SKIPEMITC
	ls -l $meltprevstage/$meltbase*
	for meltprevf in $meltprevstage/$meltbase.c  $meltprevstage/$meltbase+[0-9][0-9].c  $meltprevstage/$meltbase+meltdesc.c  $meltprevstage/$meltbase+melttime.h   $meltprevstage/$meltbase+meltbuild.mk ; do
	    meltbuild_symlink $meltprevf $meltstage/`basename $meltprevf`
	done
	meltbuild_info $meltfrom symlinked previous stage $meltprevstage/$meltbase
    fi
    GCCMELT_STAGE=$meltstage
    GCCMELT_BASE=$meltbase
} ################################ end function meltbuild_emit

################################################################
################################################################
#################@ before our stages melt-build-script.tpl:329/182 
### Our stages  
### are incrementally built, with the former modules of
### the current stage and the later modules of the previous stages
### used to emit the source of the current module in the current stage.
### This is a kind of "diagonalization".


################################################################
#### function to do a stage melt-build-script.tpl:338/183
function meltbuild_do_stage () {
    local meltfrom=$1
    local meltcurstagedir=$2
    local meltcurflavor=$3
    local meltprevstagedir=$4
    local meltprevflavor=$5

    local meltchecksum_FIRST

    local meltchecksum_BASE

    local meltchecksum_DEBUG

    local meltchecksum_MACRO

    local meltchecksum_NORMAL

    local meltchecksum_NORMATCH

    local meltchecksum_GENOBJ

    local meltchecksum_OUTOBJ

    local meltchecksum_HOOKS

    local meltchecksum_MODES

    local meltstamp
    local meltstamptmp
#### meltbuild_do_stage melt-build-script.tpl:350/184
    meltbuild_notice "$meltcurstagedir+" starting  stage $meltcurstagedir flavor $meltcurflavor from $meltfrom
####  meltbuild_do_stage melt-build-script.tpl:352/185
    meltbuild_info $meltfrom starting stage $meltcurstagedir flavor $meltcurflavor previous $meltprevstagedir previous flavor $meltprevflavor
    [ -d $meltcurstagedir ] || mkdir $meltcurstagedir
    if [ ! -d "$meltprevstagedir" -o ! -f "$meltprevstagedir/$meltprevstagedir.stamp" ]; then
	meltbuild_error $meltfrom previous stage "$meltprevstagedir/" without stamp file $meltprevstagedir/$meltprevstagedir.stamp
    fi



    #in meltbuild_do_stage melt-build-script.tpl:362/186 base warmelt-first
    meltbuild_info melt-build-script.tpl:363/187 from $meltfrom generating C code of warmelt-first in $meltcurstagedir

    #in meltbuild_do_stage melt-build-script.tpl:365/188 emit C code for warmelt-first
    meltbuild_emit melt-build-script.tpl:366/189-$meltfrom \
	translateinit \
	warmelt-first \
	"$meltcurstagedir" \
	"$meltprevstagedir" \
	$meltprevstagedir/warmelt-first.$meltprevflavor:$meltprevstagedir/warmelt-base.$meltprevflavor:$meltprevstagedir/warmelt-debug.$meltprevflavor:$meltprevstagedir/warmelt-macro.$meltprevflavor:$meltprevstagedir/warmelt-normal.$meltprevflavor:$meltprevstagedir/warmelt-normatch.$meltprevflavor:$meltprevstagedir/warmelt-genobj.$meltprevflavor:$meltprevstagedir/warmelt-outobj.$meltprevflavor:$meltprevstagedir/warmelt-hooks.$meltprevflavor:$meltprevstagedir/warmelt-modes.$meltprevflavor \
    ""

    #in meltbuild_do_stage melt-build-script.tpl:378/190 checksum C code for warmelt-first
    meltchecksum_cumul_FIRST=$(cat "$meltcurstagedir"/warmelt-first.c "$meltcurstagedir"/warmelt-first+[0-9][0-9].c | $MD5SUM | cut -b 1-32)

    #in meltbuild_do_stage melt-build-script.tpl:381/191 perhaps compiling C code for warmelt-first
    if [ -z "$GCCMELT_SKIPEMITC" ]; then
	meltbuild_info melt-build-script.tpl:383/192-$meltfrom compiling module warmelt-first in "$meltcurstagedir"
	$GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	    GCCMELT_FROM="melt-build-script.tpl:385/193-$meltfrom" \
	    GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	    GCCMELT_MODULE_FLAVOR="$meltcurflavor" \
	    GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	    GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	    GCCMELT_MODULE_SOURCEBASE="$meltcurstagedir/warmelt-first" \
	    GCCMELT_MODULE_BINARYBASE="$meltcurstagedir/warmelt-first" \
	|| meltbuild_error  melt-build-script.tpl:392/194-$meltfrom in "$meltcurstagedir/" failed to make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" module warmelt-first compiler "$GCCMELT_COMPILER" cflags "$GCCMELT_COMPILER_FLAGS"
    else
	meltbuild_info melt-build-script.tpl:394/195-$meltfrom NOT compiling module warmelt-first "in" \
	    "$meltcurstagedir/" but symlinking previous "$meltprevstagedir/" module warmelt-first \
	    checksum $meltchecksum_cumul_FIRST skipemitc=$GCCMELT_SKIPEMITC.
	meltbuild_symlink "$meltprevstagedir/warmelt-first.meltmod-$meltchecksum_cumul_FIRST.$meltprevflavor.so" \
	    "$meltcurstagedir/warmelt-first.meltmod-$meltchecksum_cumul_FIRST.$meltcurflavor.so"
    fi
    #in meltbuild_do_stage melt-build-script.tpl:400/196 done base warmelt-first


    #in meltbuild_do_stage melt-build-script.tpl:362/197 base warmelt-base
    meltbuild_info melt-build-script.tpl:363/198 from $meltfrom generating C code of warmelt-base in $meltcurstagedir

    #in meltbuild_do_stage melt-build-script.tpl:365/199 emit C code for warmelt-base
    meltbuild_emit melt-build-script.tpl:366/200-$meltfrom \
	translatefile \
	warmelt-base \
	"$meltcurstagedir" \
	"$meltprevstagedir" \
	$meltcurstagedir/warmelt-first.$meltcurflavor:$meltprevstagedir/warmelt-base.$meltprevflavor:$meltprevstagedir/warmelt-debug.$meltprevflavor:$meltprevstagedir/warmelt-macro.$meltprevflavor:$meltprevstagedir/warmelt-normal.$meltprevflavor:$meltprevstagedir/warmelt-normatch.$meltprevflavor:$meltprevstagedir/warmelt-genobj.$meltprevflavor:$meltprevstagedir/warmelt-outobj.$meltprevflavor:$meltprevstagedir/warmelt-hooks.$meltprevflavor:$meltprevstagedir/warmelt-modes.$meltprevflavor \
    ""

    #in meltbuild_do_stage melt-build-script.tpl:378/201 checksum C code for warmelt-base
    meltchecksum_cumul_BASE=$(cat "$meltcurstagedir"/warmelt-base.c "$meltcurstagedir"/warmelt-base+[0-9][0-9].c | $MD5SUM | cut -b 1-32)

    #in meltbuild_do_stage melt-build-script.tpl:381/202 perhaps compiling C code for warmelt-base
    if [ -z "$GCCMELT_SKIPEMITC" ]; then
	meltbuild_info melt-build-script.tpl:383/203-$meltfrom compiling module warmelt-base in "$meltcurstagedir"
	$GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	    GCCMELT_FROM="melt-build-script.tpl:385/204-$meltfrom" \
	    GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	    GCCMELT_MODULE_FLAVOR="$meltcurflavor" \
	    GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	    GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	    GCCMELT_MODULE_SOURCEBASE="$meltcurstagedir/warmelt-base" \
	    GCCMELT_MODULE_BINARYBASE="$meltcurstagedir/warmelt-base" \
	|| meltbuild_error  melt-build-script.tpl:392/205-$meltfrom in "$meltcurstagedir/" failed to make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" module warmelt-base compiler "$GCCMELT_COMPILER" cflags "$GCCMELT_COMPILER_FLAGS"
    else
	meltbuild_info melt-build-script.tpl:394/206-$meltfrom NOT compiling module warmelt-base "in" \
	    "$meltcurstagedir/" but symlinking previous "$meltprevstagedir/" module warmelt-base \
	    checksum $meltchecksum_cumul_BASE skipemitc=$GCCMELT_SKIPEMITC.
	meltbuild_symlink "$meltprevstagedir/warmelt-base.meltmod-$meltchecksum_cumul_BASE.$meltprevflavor.so" \
	    "$meltcurstagedir/warmelt-base.meltmod-$meltchecksum_cumul_BASE.$meltcurflavor.so"
    fi
    #in meltbuild_do_stage melt-build-script.tpl:400/207 done base warmelt-base


    #in meltbuild_do_stage melt-build-script.tpl:362/208 base warmelt-debug
    meltbuild_info melt-build-script.tpl:363/209 from $meltfrom generating C code of warmelt-debug in $meltcurstagedir

    #in meltbuild_do_stage melt-build-script.tpl:365/210 emit C code for warmelt-debug
    meltbuild_emit melt-build-script.tpl:366/211-$meltfrom \
	translatefile \
	warmelt-debug \
	"$meltcurstagedir" \
	"$meltprevstagedir" \
	$meltcurstagedir/warmelt-first.$meltcurflavor:$meltcurstagedir/warmelt-base.$meltcurflavor:$meltprevstagedir/warmelt-debug.$meltprevflavor:$meltprevstagedir/warmelt-macro.$meltprevflavor:$meltprevstagedir/warmelt-normal.$meltprevflavor:$meltprevstagedir/warmelt-normatch.$meltprevflavor:$meltprevstagedir/warmelt-genobj.$meltprevflavor:$meltprevstagedir/warmelt-outobj.$meltprevflavor:$meltprevstagedir/warmelt-hooks.$meltprevflavor:$meltprevstagedir/warmelt-modes.$meltprevflavor \
    ""

    #in meltbuild_do_stage melt-build-script.tpl:378/212 checksum C code for warmelt-debug
    meltchecksum_cumul_DEBUG=$(cat "$meltcurstagedir"/warmelt-debug.c "$meltcurstagedir"/warmelt-debug+[0-9][0-9].c | $MD5SUM | cut -b 1-32)

    #in meltbuild_do_stage melt-build-script.tpl:381/213 perhaps compiling C code for warmelt-debug
    if [ -z "$GCCMELT_SKIPEMITC" ]; then
	meltbuild_info melt-build-script.tpl:383/214-$meltfrom compiling module warmelt-debug in "$meltcurstagedir"
	$GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	    GCCMELT_FROM="melt-build-script.tpl:385/215-$meltfrom" \
	    GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	    GCCMELT_MODULE_FLAVOR="$meltcurflavor" \
	    GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	    GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	    GCCMELT_MODULE_SOURCEBASE="$meltcurstagedir/warmelt-debug" \
	    GCCMELT_MODULE_BINARYBASE="$meltcurstagedir/warmelt-debug" \
	|| meltbuild_error  melt-build-script.tpl:392/216-$meltfrom in "$meltcurstagedir/" failed to make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" module warmelt-debug compiler "$GCCMELT_COMPILER" cflags "$GCCMELT_COMPILER_FLAGS"
    else
	meltbuild_info melt-build-script.tpl:394/217-$meltfrom NOT compiling module warmelt-debug "in" \
	    "$meltcurstagedir/" but symlinking previous "$meltprevstagedir/" module warmelt-debug \
	    checksum $meltchecksum_cumul_DEBUG skipemitc=$GCCMELT_SKIPEMITC.
	meltbuild_symlink "$meltprevstagedir/warmelt-debug.meltmod-$meltchecksum_cumul_DEBUG.$meltprevflavor.so" \
	    "$meltcurstagedir/warmelt-debug.meltmod-$meltchecksum_cumul_DEBUG.$meltcurflavor.so"
    fi
    #in meltbuild_do_stage melt-build-script.tpl:400/218 done base warmelt-debug


    #in meltbuild_do_stage melt-build-script.tpl:362/219 base warmelt-macro
    meltbuild_info melt-build-script.tpl:363/220 from $meltfrom generating C code of warmelt-macro in $meltcurstagedir

    #in meltbuild_do_stage melt-build-script.tpl:365/221 emit C code for warmelt-macro
    meltbuild_emit melt-build-script.tpl:366/222-$meltfrom \
	translatefile \
	warmelt-macro \
	"$meltcurstagedir" \
	"$meltprevstagedir" \
	$meltcurstagedir/warmelt-first.$meltcurflavor:$meltcurstagedir/warmelt-base.$meltcurflavor:$meltcurstagedir/warmelt-debug.$meltcurflavor:$meltprevstagedir/warmelt-macro.$meltprevflavor:$meltprevstagedir/warmelt-normal.$meltprevflavor:$meltprevstagedir/warmelt-normatch.$meltprevflavor:$meltprevstagedir/warmelt-genobj.$meltprevflavor:$meltprevstagedir/warmelt-outobj.$meltprevflavor:$meltprevstagedir/warmelt-hooks.$meltprevflavor:$meltprevstagedir/warmelt-modes.$meltprevflavor \
    ""

    #in meltbuild_do_stage melt-build-script.tpl:378/223 checksum C code for warmelt-macro
    meltchecksum_cumul_MACRO=$(cat "$meltcurstagedir"/warmelt-macro.c "$meltcurstagedir"/warmelt-macro+[0-9][0-9].c | $MD5SUM | cut -b 1-32)

    #in meltbuild_do_stage melt-build-script.tpl:381/224 perhaps compiling C code for warmelt-macro
    if [ -z "$GCCMELT_SKIPEMITC" ]; then
	meltbuild_info melt-build-script.tpl:383/225-$meltfrom compiling module warmelt-macro in "$meltcurstagedir"
	$GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	    GCCMELT_FROM="melt-build-script.tpl:385/226-$meltfrom" \
	    GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	    GCCMELT_MODULE_FLAVOR="$meltcurflavor" \
	    GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	    GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	    GCCMELT_MODULE_SOURCEBASE="$meltcurstagedir/warmelt-macro" \
	    GCCMELT_MODULE_BINARYBASE="$meltcurstagedir/warmelt-macro" \
	|| meltbuild_error  melt-build-script.tpl:392/227-$meltfrom in "$meltcurstagedir/" failed to make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" module warmelt-macro compiler "$GCCMELT_COMPILER" cflags "$GCCMELT_COMPILER_FLAGS"
    else
	meltbuild_info melt-build-script.tpl:394/228-$meltfrom NOT compiling module warmelt-macro "in" \
	    "$meltcurstagedir/" but symlinking previous "$meltprevstagedir/" module warmelt-macro \
	    checksum $meltchecksum_cumul_MACRO skipemitc=$GCCMELT_SKIPEMITC.
	meltbuild_symlink "$meltprevstagedir/warmelt-macro.meltmod-$meltchecksum_cumul_MACRO.$meltprevflavor.so" \
	    "$meltcurstagedir/warmelt-macro.meltmod-$meltchecksum_cumul_MACRO.$meltcurflavor.so"
    fi
    #in meltbuild_do_stage melt-build-script.tpl:400/229 done base warmelt-macro


    #in meltbuild_do_stage melt-build-script.tpl:362/230 base warmelt-normal
    meltbuild_info melt-build-script.tpl:363/231 from $meltfrom generating C code of warmelt-normal in $meltcurstagedir

    #in meltbuild_do_stage melt-build-script.tpl:365/232 emit C code for warmelt-normal
    meltbuild_emit melt-build-script.tpl:366/233-$meltfrom \
	translatefile \
	warmelt-normal \
	"$meltcurstagedir" \
	"$meltprevstagedir" \
	$meltcurstagedir/warmelt-first.$meltcurflavor:$meltcurstagedir/warmelt-base.$meltcurflavor:$meltcurstagedir/warmelt-debug.$meltcurflavor:$meltcurstagedir/warmelt-macro.$meltcurflavor:$meltprevstagedir/warmelt-normal.$meltprevflavor:$meltprevstagedir/warmelt-normatch.$meltprevflavor:$meltprevstagedir/warmelt-genobj.$meltprevflavor:$meltprevstagedir/warmelt-outobj.$meltprevflavor:$meltprevstagedir/warmelt-hooks.$meltprevflavor:$meltprevstagedir/warmelt-modes.$meltprevflavor \
    "warmelt-predef.melt"

    #in meltbuild_do_stage melt-build-script.tpl:378/234 checksum C code for warmelt-normal
    meltchecksum_cumul_NORMAL=$(cat "$meltcurstagedir"/warmelt-normal.c "$meltcurstagedir"/warmelt-normal+[0-9][0-9].c | $MD5SUM | cut -b 1-32)

    #in meltbuild_do_stage melt-build-script.tpl:381/235 perhaps compiling C code for warmelt-normal
    if [ -z "$GCCMELT_SKIPEMITC" ]; then
	meltbuild_info melt-build-script.tpl:383/236-$meltfrom compiling module warmelt-normal in "$meltcurstagedir"
	$GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	    GCCMELT_FROM="melt-build-script.tpl:385/237-$meltfrom" \
	    GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	    GCCMELT_MODULE_FLAVOR="$meltcurflavor" \
	    GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	    GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	    GCCMELT_MODULE_SOURCEBASE="$meltcurstagedir/warmelt-normal" \
	    GCCMELT_MODULE_BINARYBASE="$meltcurstagedir/warmelt-normal" \
	|| meltbuild_error  melt-build-script.tpl:392/238-$meltfrom in "$meltcurstagedir/" failed to make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" module warmelt-normal compiler "$GCCMELT_COMPILER" cflags "$GCCMELT_COMPILER_FLAGS"
    else
	meltbuild_info melt-build-script.tpl:394/239-$meltfrom NOT compiling module warmelt-normal "in" \
	    "$meltcurstagedir/" but symlinking previous "$meltprevstagedir/" module warmelt-normal \
	    checksum $meltchecksum_cumul_NORMAL skipemitc=$GCCMELT_SKIPEMITC.
	meltbuild_symlink "$meltprevstagedir/warmelt-normal.meltmod-$meltchecksum_cumul_NORMAL.$meltprevflavor.so" \
	    "$meltcurstagedir/warmelt-normal.meltmod-$meltchecksum_cumul_NORMAL.$meltcurflavor.so"
    fi
    #in meltbuild_do_stage melt-build-script.tpl:400/240 done base warmelt-normal


    #in meltbuild_do_stage melt-build-script.tpl:362/241 base warmelt-normatch
    meltbuild_info melt-build-script.tpl:363/242 from $meltfrom generating C code of warmelt-normatch in $meltcurstagedir

    #in meltbuild_do_stage melt-build-script.tpl:365/243 emit C code for warmelt-normatch
    meltbuild_emit melt-build-script.tpl:366/244-$meltfrom \
	translatefile \
	warmelt-normatch \
	"$meltcurstagedir" \
	"$meltprevstagedir" \
	$meltcurstagedir/warmelt-first.$meltcurflavor:$meltcurstagedir/warmelt-base.$meltcurflavor:$meltcurstagedir/warmelt-debug.$meltcurflavor:$meltcurstagedir/warmelt-macro.$meltcurflavor:$meltcurstagedir/warmelt-normal.$meltcurflavor:$meltprevstagedir/warmelt-normatch.$meltprevflavor:$meltprevstagedir/warmelt-genobj.$meltprevflavor:$meltprevstagedir/warmelt-outobj.$meltprevflavor:$meltprevstagedir/warmelt-hooks.$meltprevflavor:$meltprevstagedir/warmelt-modes.$meltprevflavor \
    ""

    #in meltbuild_do_stage melt-build-script.tpl:378/245 checksum C code for warmelt-normatch
    meltchecksum_cumul_NORMATCH=$(cat "$meltcurstagedir"/warmelt-normatch.c "$meltcurstagedir"/warmelt-normatch+[0-9][0-9].c | $MD5SUM | cut -b 1-32)

    #in meltbuild_do_stage melt-build-script.tpl:381/246 perhaps compiling C code for warmelt-normatch
    if [ -z "$GCCMELT_SKIPEMITC" ]; then
	meltbuild_info melt-build-script.tpl:383/247-$meltfrom compiling module warmelt-normatch in "$meltcurstagedir"
	$GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	    GCCMELT_FROM="melt-build-script.tpl:385/248-$meltfrom" \
	    GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	    GCCMELT_MODULE_FLAVOR="$meltcurflavor" \
	    GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	    GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	    GCCMELT_MODULE_SOURCEBASE="$meltcurstagedir/warmelt-normatch" \
	    GCCMELT_MODULE_BINARYBASE="$meltcurstagedir/warmelt-normatch" \
	|| meltbuild_error  melt-build-script.tpl:392/249-$meltfrom in "$meltcurstagedir/" failed to make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" module warmelt-normatch compiler "$GCCMELT_COMPILER" cflags "$GCCMELT_COMPILER_FLAGS"
    else
	meltbuild_info melt-build-script.tpl:394/250-$meltfrom NOT compiling module warmelt-normatch "in" \
	    "$meltcurstagedir/" but symlinking previous "$meltprevstagedir/" module warmelt-normatch \
	    checksum $meltchecksum_cumul_NORMATCH skipemitc=$GCCMELT_SKIPEMITC.
	meltbuild_symlink "$meltprevstagedir/warmelt-normatch.meltmod-$meltchecksum_cumul_NORMATCH.$meltprevflavor.so" \
	    "$meltcurstagedir/warmelt-normatch.meltmod-$meltchecksum_cumul_NORMATCH.$meltcurflavor.so"
    fi
    #in meltbuild_do_stage melt-build-script.tpl:400/251 done base warmelt-normatch


    #in meltbuild_do_stage melt-build-script.tpl:362/252 base warmelt-genobj
    meltbuild_info melt-build-script.tpl:363/253 from $meltfrom generating C code of warmelt-genobj in $meltcurstagedir

    #in meltbuild_do_stage melt-build-script.tpl:365/254 emit C code for warmelt-genobj
    meltbuild_emit melt-build-script.tpl:366/255-$meltfrom \
	translatefile \
	warmelt-genobj \
	"$meltcurstagedir" \
	"$meltprevstagedir" \
	$meltcurstagedir/warmelt-first.$meltcurflavor:$meltcurstagedir/warmelt-base.$meltcurflavor:$meltcurstagedir/warmelt-debug.$meltcurflavor:$meltcurstagedir/warmelt-macro.$meltcurflavor:$meltcurstagedir/warmelt-normal.$meltcurflavor:$meltcurstagedir/warmelt-normatch.$meltcurflavor:$meltprevstagedir/warmelt-genobj.$meltprevflavor:$meltprevstagedir/warmelt-outobj.$meltprevflavor:$meltprevstagedir/warmelt-hooks.$meltprevflavor:$meltprevstagedir/warmelt-modes.$meltprevflavor \
    ""

    #in meltbuild_do_stage melt-build-script.tpl:378/256 checksum C code for warmelt-genobj
    meltchecksum_cumul_GENOBJ=$(cat "$meltcurstagedir"/warmelt-genobj.c "$meltcurstagedir"/warmelt-genobj+[0-9][0-9].c | $MD5SUM | cut -b 1-32)

    #in meltbuild_do_stage melt-build-script.tpl:381/257 perhaps compiling C code for warmelt-genobj
    if [ -z "$GCCMELT_SKIPEMITC" ]; then
	meltbuild_info melt-build-script.tpl:383/258-$meltfrom compiling module warmelt-genobj in "$meltcurstagedir"
	$GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	    GCCMELT_FROM="melt-build-script.tpl:385/259-$meltfrom" \
	    GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	    GCCMELT_MODULE_FLAVOR="$meltcurflavor" \
	    GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	    GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	    GCCMELT_MODULE_SOURCEBASE="$meltcurstagedir/warmelt-genobj" \
	    GCCMELT_MODULE_BINARYBASE="$meltcurstagedir/warmelt-genobj" \
	|| meltbuild_error  melt-build-script.tpl:392/260-$meltfrom in "$meltcurstagedir/" failed to make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" module warmelt-genobj compiler "$GCCMELT_COMPILER" cflags "$GCCMELT_COMPILER_FLAGS"
    else
	meltbuild_info melt-build-script.tpl:394/261-$meltfrom NOT compiling module warmelt-genobj "in" \
	    "$meltcurstagedir/" but symlinking previous "$meltprevstagedir/" module warmelt-genobj \
	    checksum $meltchecksum_cumul_GENOBJ skipemitc=$GCCMELT_SKIPEMITC.
	meltbuild_symlink "$meltprevstagedir/warmelt-genobj.meltmod-$meltchecksum_cumul_GENOBJ.$meltprevflavor.so" \
	    "$meltcurstagedir/warmelt-genobj.meltmod-$meltchecksum_cumul_GENOBJ.$meltcurflavor.so"
    fi
    #in meltbuild_do_stage melt-build-script.tpl:400/262 done base warmelt-genobj


    #in meltbuild_do_stage melt-build-script.tpl:362/263 base warmelt-outobj
    meltbuild_info melt-build-script.tpl:363/264 from $meltfrom generating C code of warmelt-outobj in $meltcurstagedir

    #in meltbuild_do_stage melt-build-script.tpl:365/265 emit C code for warmelt-outobj
    meltbuild_emit melt-build-script.tpl:366/266-$meltfrom \
	translatefile \
	warmelt-outobj \
	"$meltcurstagedir" \
	"$meltprevstagedir" \
	$meltcurstagedir/warmelt-first.$meltcurflavor:$meltcurstagedir/warmelt-base.$meltcurflavor:$meltcurstagedir/warmelt-debug.$meltcurflavor:$meltcurstagedir/warmelt-macro.$meltcurflavor:$meltcurstagedir/warmelt-normal.$meltcurflavor:$meltcurstagedir/warmelt-normatch.$meltcurflavor:$meltcurstagedir/warmelt-genobj.$meltcurflavor:$meltprevstagedir/warmelt-outobj.$meltprevflavor:$meltprevstagedir/warmelt-hooks.$meltprevflavor:$meltprevstagedir/warmelt-modes.$meltprevflavor \
    ""

    #in meltbuild_do_stage melt-build-script.tpl:378/267 checksum C code for warmelt-outobj
    meltchecksum_cumul_OUTOBJ=$(cat "$meltcurstagedir"/warmelt-outobj.c "$meltcurstagedir"/warmelt-outobj+[0-9][0-9].c | $MD5SUM | cut -b 1-32)

    #in meltbuild_do_stage melt-build-script.tpl:381/268 perhaps compiling C code for warmelt-outobj
    if [ -z "$GCCMELT_SKIPEMITC" ]; then
	meltbuild_info melt-build-script.tpl:383/269-$meltfrom compiling module warmelt-outobj in "$meltcurstagedir"
	$GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	    GCCMELT_FROM="melt-build-script.tpl:385/270-$meltfrom" \
	    GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	    GCCMELT_MODULE_FLAVOR="$meltcurflavor" \
	    GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	    GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	    GCCMELT_MODULE_SOURCEBASE="$meltcurstagedir/warmelt-outobj" \
	    GCCMELT_MODULE_BINARYBASE="$meltcurstagedir/warmelt-outobj" \
	|| meltbuild_error  melt-build-script.tpl:392/271-$meltfrom in "$meltcurstagedir/" failed to make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" module warmelt-outobj compiler "$GCCMELT_COMPILER" cflags "$GCCMELT_COMPILER_FLAGS"
    else
	meltbuild_info melt-build-script.tpl:394/272-$meltfrom NOT compiling module warmelt-outobj "in" \
	    "$meltcurstagedir/" but symlinking previous "$meltprevstagedir/" module warmelt-outobj \
	    checksum $meltchecksum_cumul_OUTOBJ skipemitc=$GCCMELT_SKIPEMITC.
	meltbuild_symlink "$meltprevstagedir/warmelt-outobj.meltmod-$meltchecksum_cumul_OUTOBJ.$meltprevflavor.so" \
	    "$meltcurstagedir/warmelt-outobj.meltmod-$meltchecksum_cumul_OUTOBJ.$meltcurflavor.so"
    fi
    #in meltbuild_do_stage melt-build-script.tpl:400/273 done base warmelt-outobj


    #in meltbuild_do_stage melt-build-script.tpl:362/274 base warmelt-hooks
    meltbuild_info melt-build-script.tpl:363/275 from $meltfrom generating C code of warmelt-hooks in $meltcurstagedir

    #in meltbuild_do_stage melt-build-script.tpl:365/276 emit C code for warmelt-hooks
    meltbuild_emit melt-build-script.tpl:366/277-$meltfrom \
	translatefile \
	warmelt-hooks \
	"$meltcurstagedir" \
	"$meltprevstagedir" \
	$meltcurstagedir/warmelt-first.$meltcurflavor:$meltcurstagedir/warmelt-base.$meltcurflavor:$meltcurstagedir/warmelt-debug.$meltcurflavor:$meltcurstagedir/warmelt-macro.$meltcurflavor:$meltcurstagedir/warmelt-normal.$meltcurflavor:$meltcurstagedir/warmelt-normatch.$meltcurflavor:$meltcurstagedir/warmelt-genobj.$meltcurflavor:$meltcurstagedir/warmelt-outobj.$meltcurflavor:$meltprevstagedir/warmelt-hooks.$meltprevflavor:$meltprevstagedir/warmelt-modes.$meltprevflavor \
    ""

    #in meltbuild_do_stage melt-build-script.tpl:378/278 checksum C code for warmelt-hooks
    meltchecksum_cumul_HOOKS=$(cat "$meltcurstagedir"/warmelt-hooks.c "$meltcurstagedir"/warmelt-hooks+[0-9][0-9].c | $MD5SUM | cut -b 1-32)

    #in meltbuild_do_stage melt-build-script.tpl:381/279 perhaps compiling C code for warmelt-hooks
    if [ -z "$GCCMELT_SKIPEMITC" ]; then
	meltbuild_info melt-build-script.tpl:383/280-$meltfrom compiling module warmelt-hooks in "$meltcurstagedir"
	$GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	    GCCMELT_FROM="melt-build-script.tpl:385/281-$meltfrom" \
	    GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	    GCCMELT_MODULE_FLAVOR="$meltcurflavor" \
	    GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	    GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	    GCCMELT_MODULE_SOURCEBASE="$meltcurstagedir/warmelt-hooks" \
	    GCCMELT_MODULE_BINARYBASE="$meltcurstagedir/warmelt-hooks" \
	|| meltbuild_error  melt-build-script.tpl:392/282-$meltfrom in "$meltcurstagedir/" failed to make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" module warmelt-hooks compiler "$GCCMELT_COMPILER" cflags "$GCCMELT_COMPILER_FLAGS"
    else
	meltbuild_info melt-build-script.tpl:394/283-$meltfrom NOT compiling module warmelt-hooks "in" \
	    "$meltcurstagedir/" but symlinking previous "$meltprevstagedir/" module warmelt-hooks \
	    checksum $meltchecksum_cumul_HOOKS skipemitc=$GCCMELT_SKIPEMITC.
	meltbuild_symlink "$meltprevstagedir/warmelt-hooks.meltmod-$meltchecksum_cumul_HOOKS.$meltprevflavor.so" \
	    "$meltcurstagedir/warmelt-hooks.meltmod-$meltchecksum_cumul_HOOKS.$meltcurflavor.so"
    fi
    #in meltbuild_do_stage melt-build-script.tpl:400/284 done base warmelt-hooks


    #in meltbuild_do_stage melt-build-script.tpl:362/285 base warmelt-modes
    meltbuild_info melt-build-script.tpl:363/286 from $meltfrom generating C code of warmelt-modes in $meltcurstagedir

    #in meltbuild_do_stage melt-build-script.tpl:365/287 emit C code for warmelt-modes
    meltbuild_emit melt-build-script.tpl:366/288-$meltfrom \
	translatefile \
	warmelt-modes \
	"$meltcurstagedir" \
	"$meltprevstagedir" \
	$meltcurstagedir/warmelt-first.$meltcurflavor:$meltcurstagedir/warmelt-base.$meltcurflavor:$meltcurstagedir/warmelt-debug.$meltcurflavor:$meltcurstagedir/warmelt-macro.$meltcurflavor:$meltcurstagedir/warmelt-normal.$meltcurflavor:$meltcurstagedir/warmelt-normatch.$meltcurflavor:$meltcurstagedir/warmelt-genobj.$meltcurflavor:$meltcurstagedir/warmelt-outobj.$meltcurflavor:$meltcurstagedir/warmelt-hooks.$meltcurflavor:$meltprevstagedir/warmelt-modes.$meltprevflavor \
    ""

    #in meltbuild_do_stage melt-build-script.tpl:378/289 checksum C code for warmelt-modes
    meltchecksum_cumul_MODES=$(cat "$meltcurstagedir"/warmelt-modes.c "$meltcurstagedir"/warmelt-modes+[0-9][0-9].c | $MD5SUM | cut -b 1-32)

    #in meltbuild_do_stage melt-build-script.tpl:381/290 perhaps compiling C code for warmelt-modes
    if [ -z "$GCCMELT_SKIPEMITC" ]; then
	meltbuild_info melt-build-script.tpl:383/291-$meltfrom compiling module warmelt-modes in "$meltcurstagedir"
	$GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	    GCCMELT_FROM="melt-build-script.tpl:385/292-$meltfrom" \
	    GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	    GCCMELT_MODULE_FLAVOR="$meltcurflavor" \
	    GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	    GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	    GCCMELT_MODULE_SOURCEBASE="$meltcurstagedir/warmelt-modes" \
	    GCCMELT_MODULE_BINARYBASE="$meltcurstagedir/warmelt-modes" \
	|| meltbuild_error  melt-build-script.tpl:392/293-$meltfrom in "$meltcurstagedir/" failed to make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" module warmelt-modes compiler "$GCCMELT_COMPILER" cflags "$GCCMELT_COMPILER_FLAGS"
    else
	meltbuild_info melt-build-script.tpl:394/294-$meltfrom NOT compiling module warmelt-modes "in" \
	    "$meltcurstagedir/" but symlinking previous "$meltprevstagedir/" module warmelt-modes \
	    checksum $meltchecksum_cumul_MODES skipemitc=$GCCMELT_SKIPEMITC.
	meltbuild_symlink "$meltprevstagedir/warmelt-modes.meltmod-$meltchecksum_cumul_MODES.$meltprevflavor.so" \
	    "$meltcurstagedir/warmelt-modes.meltmod-$meltchecksum_cumul_MODES.$meltcurflavor.so"
    fi
    #in meltbuild_do_stage melt-build-script.tpl:400/295 done base warmelt-modes


    #in meltbuild_do_stage melt-build-script.tpl:403/296 generating the stampfile
    meltstamp=$meltcurstagedir/$meltcurstagedir.stamp
    meltstamptmp=$meltstamp-tmp$$
    echo "///timestamp file $meltstamp" > $meltstamptmp
    echo $GCCMELT_RUNTIME_DEPENDENCY_MD5SUM $GCCMELT_RUNTIME_DEPENDENCY >> $meltstamptmp

    $MD5SUM $meltcurstagedir/warmelt-first.c $meltcurstagedir/warmelt-first+[0-9][0-9].c  >> $meltstamptmp
    $MD5SUM "$meltcurstagedir/warmelt-first.meltmod-$meltchecksum_cumul_FIRST.$meltcurflavor.so"  >> $meltstamptmp

    $MD5SUM $meltcurstagedir/warmelt-base.c $meltcurstagedir/warmelt-base+[0-9][0-9].c  >> $meltstamptmp
    $MD5SUM "$meltcurstagedir/warmelt-base.meltmod-$meltchecksum_cumul_BASE.$meltcurflavor.so"  >> $meltstamptmp

    $MD5SUM $meltcurstagedir/warmelt-debug.c $meltcurstagedir/warmelt-debug+[0-9][0-9].c  >> $meltstamptmp
    $MD5SUM "$meltcurstagedir/warmelt-debug.meltmod-$meltchecksum_cumul_DEBUG.$meltcurflavor.so"  >> $meltstamptmp

    $MD5SUM $meltcurstagedir/warmelt-macro.c $meltcurstagedir/warmelt-macro+[0-9][0-9].c  >> $meltstamptmp
    $MD5SUM "$meltcurstagedir/warmelt-macro.meltmod-$meltchecksum_cumul_MACRO.$meltcurflavor.so"  >> $meltstamptmp

    $MD5SUM $meltcurstagedir/warmelt-normal.c $meltcurstagedir/warmelt-normal+[0-9][0-9].c  >> $meltstamptmp
    $MD5SUM "$meltcurstagedir/warmelt-normal.meltmod-$meltchecksum_cumul_NORMAL.$meltcurflavor.so"  >> $meltstamptmp

    $MD5SUM $meltcurstagedir/warmelt-normatch.c $meltcurstagedir/warmelt-normatch+[0-9][0-9].c  >> $meltstamptmp
    $MD5SUM "$meltcurstagedir/warmelt-normatch.meltmod-$meltchecksum_cumul_NORMATCH.$meltcurflavor.so"  >> $meltstamptmp

    $MD5SUM $meltcurstagedir/warmelt-genobj.c $meltcurstagedir/warmelt-genobj+[0-9][0-9].c  >> $meltstamptmp
    $MD5SUM "$meltcurstagedir/warmelt-genobj.meltmod-$meltchecksum_cumul_GENOBJ.$meltcurflavor.so"  >> $meltstamptmp

    $MD5SUM $meltcurstagedir/warmelt-outobj.c $meltcurstagedir/warmelt-outobj+[0-9][0-9].c  >> $meltstamptmp
    $MD5SUM "$meltcurstagedir/warmelt-outobj.meltmod-$meltchecksum_cumul_OUTOBJ.$meltcurflavor.so"  >> $meltstamptmp

    $MD5SUM $meltcurstagedir/warmelt-hooks.c $meltcurstagedir/warmelt-hooks+[0-9][0-9].c  >> $meltstamptmp
    $MD5SUM "$meltcurstagedir/warmelt-hooks.meltmod-$meltchecksum_cumul_HOOKS.$meltcurflavor.so"  >> $meltstamptmp

    $MD5SUM $meltcurstagedir/warmelt-modes.c $meltcurstagedir/warmelt-modes+[0-9][0-9].c  >> $meltstamptmp
    $MD5SUM "$meltcurstagedir/warmelt-modes.meltmod-$meltchecksum_cumul_MODES.$meltcurflavor.so"  >> $meltstamptmp

    echo "///end timestamp file $meltstamp"
    $GCCMELT_MOVE_IF_CHANGE $meltstamptmp $meltstamp

    #in meltbuild_do_stage melt-build-script.tpl:415/297 ending
    meltbuild_info $meltfrom done stage $meltcurstagedir flavor $meltcurflavor previous $meltprevstagedir previous flavor $meltprevflavor timestamp $meltstamp

}			#### end meltbuild_do_stage melt-build-script.tpl:418/298
################################################################

##### possibly run all our stages  melt-build-script.tpl:421/299

#@  melt-build-script.tpl:423/300 stagedir meltbuild-stage1
GCCMELT_SKIPEMITC=
if [ ! -f meltbuild-stage1/meltbuild-stage1.stamp -o meltbuild-stage1/meltbuild-stage1.stamp -ot $GCCMELT_RUNTIME_DEPENDENCY \
 -o meltbuild-stage1/meltbuild-stage1.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-first.melt \
 -o meltbuild-stage1/meltbuild-stage1.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-base.melt \
 -o meltbuild-stage1/meltbuild-stage1.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-debug.melt \
 -o meltbuild-stage1/meltbuild-stage1.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-macro.melt \
 -o meltbuild-stage1/meltbuild-stage1.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-normal.melt \
 -o meltbuild-stage1/meltbuild-stage1.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-normatch.melt \
 -o meltbuild-stage1/meltbuild-stage1.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-genobj.melt \
 -o meltbuild-stage1/meltbuild-stage1.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-outobj.melt \
 -o meltbuild-stage1/meltbuild-stage1.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-hooks.melt \
 -o meltbuild-stage1/meltbuild-stage1.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-modes.melt \
 ]; then
    echo ; echo ; echo ; echo 
    meltbuild_info  melt-build-script.tpl:429/301 '++++++++++++++++' building stage meltbuild-stage1 '++++++++++++++++'
    ## building stage meltbuild-stage1 previous $GCCMELT_STAGE_ZERO  melt-build-script.tpl:430/302
    meltbuild_do_stage  melt-build-script.tpl:431/303 meltbuild-stage1 quicklybuilt $GCCMELT_STAGE_ZERO $GCCMELT_ZERO_FLAVOR
else
    meltbuild_info  melt-build-script.tpl:433/304 skipping stage meltbuild-stage1
fi

##  melt-build-script.tpl:436/305
GCCMELT_LASTSTAGE=meltbuild-stage1


#@  melt-build-script.tpl:423/306 stagedir meltbuild-stage2
GCCMELT_SKIPEMITC=
if [ ! -f meltbuild-stage2/meltbuild-stage2.stamp -o meltbuild-stage2/meltbuild-stage2.stamp -ot $GCCMELT_RUNTIME_DEPENDENCY \
 -o meltbuild-stage2/meltbuild-stage2.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-first.melt \
 -o meltbuild-stage2/meltbuild-stage2.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-base.melt \
 -o meltbuild-stage2/meltbuild-stage2.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-debug.melt \
 -o meltbuild-stage2/meltbuild-stage2.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-macro.melt \
 -o meltbuild-stage2/meltbuild-stage2.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-normal.melt \
 -o meltbuild-stage2/meltbuild-stage2.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-normatch.melt \
 -o meltbuild-stage2/meltbuild-stage2.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-genobj.melt \
 -o meltbuild-stage2/meltbuild-stage2.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-outobj.melt \
 -o meltbuild-stage2/meltbuild-stage2.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-hooks.melt \
 -o meltbuild-stage2/meltbuild-stage2.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-modes.melt \
 ]; then
    echo ; echo ; echo ; echo 
    meltbuild_info  melt-build-script.tpl:429/307 '++++++++++++++++' building stage meltbuild-stage2 '++++++++++++++++'
    ## building stage meltbuild-stage2 previous meltbuild-stage1  melt-build-script.tpl:430/308
    meltbuild_do_stage  melt-build-script.tpl:431/309 meltbuild-stage2 quicklybuilt meltbuild-stage1 quicklybuilt
else
    meltbuild_info  melt-build-script.tpl:433/310 skipping stage meltbuild-stage2
fi

##  melt-build-script.tpl:436/311
GCCMELT_LASTSTAGE=meltbuild-stage2


#@  melt-build-script.tpl:423/312 stagedir meltbuild-stage3
GCCMELT_SKIPEMITC=
if [ ! -f meltbuild-stage3/meltbuild-stage3.stamp -o meltbuild-stage3/meltbuild-stage3.stamp -ot $GCCMELT_RUNTIME_DEPENDENCY \
 -o meltbuild-stage3/meltbuild-stage3.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-first.melt \
 -o meltbuild-stage3/meltbuild-stage3.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-base.melt \
 -o meltbuild-stage3/meltbuild-stage3.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-debug.melt \
 -o meltbuild-stage3/meltbuild-stage3.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-macro.melt \
 -o meltbuild-stage3/meltbuild-stage3.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-normal.melt \
 -o meltbuild-stage3/meltbuild-stage3.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-normatch.melt \
 -o meltbuild-stage3/meltbuild-stage3.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-genobj.melt \
 -o meltbuild-stage3/meltbuild-stage3.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-outobj.melt \
 -o meltbuild-stage3/meltbuild-stage3.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-hooks.melt \
 -o meltbuild-stage3/meltbuild-stage3.stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-modes.melt \
 ]; then
    echo ; echo ; echo ; echo 
    meltbuild_info  melt-build-script.tpl:429/313 '++++++++++++++++' building stage meltbuild-stage3 '++++++++++++++++'
    ## building stage meltbuild-stage3 previous meltbuild-stage2  melt-build-script.tpl:430/314
    meltbuild_do_stage  melt-build-script.tpl:431/315 meltbuild-stage3 quicklybuilt meltbuild-stage2 quicklybuilt
else
    meltbuild_info  melt-build-script.tpl:433/316 skipping stage meltbuild-stage3
fi

##  melt-build-script.tpl:436/317
GCCMELT_LASTSTAGE=meltbuild-stage3



################################################################


meltbuild_info melt-build-script.tpl:444/318 last stage $GCCMELT_LASTSTAGE

################################################################
################################################################
###########@ before generating meltbuild-sources melt-build-script.tpl:448/319

#### the meltbuild-sources is the final sources directory, to be
#### installed.  They are generated from the last stage, using the
#### modules inside it. Notice that in contrast from the intermediate
#### stages no "diagonalization" is involved.

[ -d meltbuild-sources ] || mkdir meltbuild-sources

#@ from  melt-build-script.tpl:457/320  compiling the modules
[ -d meltbuild-modules ] || mkdir meltbuild-modules

################################################################
function meltbuild_emit_translator_sources () {

  ## meltbuild_emit_source  melt-build-script.tpl:463/321 base warmelt-first
  meltbuild_info melt-build-script.tpl:464/322 generating C code of warmelt-first in meltbuild-sources
  meltbuild_emit melt-build-script.tpl:465/323 \
      translateinit \
      warmelt-first \
      meltbuild-sources \
      "$GCCMELT_LASTSTAGE" \
      $GCCMELT_LASTSTAGE/warmelt-first.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-base.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-debug.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-macro.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normal.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normatch.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-genobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-outobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-hooks.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-modes.quicklybuilt \
      ""

  ## meltbuild_emit_source  melt-build-script.tpl:463/324 base warmelt-base
  meltbuild_info melt-build-script.tpl:464/325 generating C code of warmelt-base in meltbuild-sources
  meltbuild_emit melt-build-script.tpl:465/326 \
      translatefile \
      warmelt-base \
      meltbuild-sources \
      "$GCCMELT_LASTSTAGE" \
      $GCCMELT_LASTSTAGE/warmelt-first.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-base.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-debug.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-macro.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normal.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normatch.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-genobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-outobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-hooks.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-modes.quicklybuilt \
      ""

  ## meltbuild_emit_source  melt-build-script.tpl:463/327 base warmelt-debug
  meltbuild_info melt-build-script.tpl:464/328 generating C code of warmelt-debug in meltbuild-sources
  meltbuild_emit melt-build-script.tpl:465/329 \
      translatefile \
      warmelt-debug \
      meltbuild-sources \
      "$GCCMELT_LASTSTAGE" \
      $GCCMELT_LASTSTAGE/warmelt-first.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-base.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-debug.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-macro.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normal.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normatch.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-genobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-outobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-hooks.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-modes.quicklybuilt \
      ""

  ## meltbuild_emit_source  melt-build-script.tpl:463/330 base warmelt-macro
  meltbuild_info melt-build-script.tpl:464/331 generating C code of warmelt-macro in meltbuild-sources
  meltbuild_emit melt-build-script.tpl:465/332 \
      translatefile \
      warmelt-macro \
      meltbuild-sources \
      "$GCCMELT_LASTSTAGE" \
      $GCCMELT_LASTSTAGE/warmelt-first.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-base.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-debug.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-macro.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normal.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normatch.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-genobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-outobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-hooks.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-modes.quicklybuilt \
      ""

  ## meltbuild_emit_source  melt-build-script.tpl:463/333 base warmelt-normal
  meltbuild_info melt-build-script.tpl:464/334 generating C code of warmelt-normal in meltbuild-sources
  meltbuild_emit melt-build-script.tpl:465/335 \
      translatefile \
      warmelt-normal \
      meltbuild-sources \
      "$GCCMELT_LASTSTAGE" \
      $GCCMELT_LASTSTAGE/warmelt-first.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-base.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-debug.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-macro.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normal.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normatch.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-genobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-outobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-hooks.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-modes.quicklybuilt \
      "warmelt-predef.melt"

  ## meltbuild_emit_source  melt-build-script.tpl:463/336 base warmelt-normatch
  meltbuild_info melt-build-script.tpl:464/337 generating C code of warmelt-normatch in meltbuild-sources
  meltbuild_emit melt-build-script.tpl:465/338 \
      translatefile \
      warmelt-normatch \
      meltbuild-sources \
      "$GCCMELT_LASTSTAGE" \
      $GCCMELT_LASTSTAGE/warmelt-first.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-base.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-debug.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-macro.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normal.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normatch.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-genobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-outobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-hooks.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-modes.quicklybuilt \
      ""

  ## meltbuild_emit_source  melt-build-script.tpl:463/339 base warmelt-genobj
  meltbuild_info melt-build-script.tpl:464/340 generating C code of warmelt-genobj in meltbuild-sources
  meltbuild_emit melt-build-script.tpl:465/341 \
      translatefile \
      warmelt-genobj \
      meltbuild-sources \
      "$GCCMELT_LASTSTAGE" \
      $GCCMELT_LASTSTAGE/warmelt-first.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-base.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-debug.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-macro.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normal.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normatch.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-genobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-outobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-hooks.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-modes.quicklybuilt \
      ""

  ## meltbuild_emit_source  melt-build-script.tpl:463/342 base warmelt-outobj
  meltbuild_info melt-build-script.tpl:464/343 generating C code of warmelt-outobj in meltbuild-sources
  meltbuild_emit melt-build-script.tpl:465/344 \
      translatefile \
      warmelt-outobj \
      meltbuild-sources \
      "$GCCMELT_LASTSTAGE" \
      $GCCMELT_LASTSTAGE/warmelt-first.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-base.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-debug.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-macro.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normal.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normatch.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-genobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-outobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-hooks.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-modes.quicklybuilt \
      ""

  ## meltbuild_emit_source  melt-build-script.tpl:463/345 base warmelt-hooks
  meltbuild_info melt-build-script.tpl:464/346 generating C code of warmelt-hooks in meltbuild-sources
  meltbuild_emit melt-build-script.tpl:465/347 \
      translatefile \
      warmelt-hooks \
      meltbuild-sources \
      "$GCCMELT_LASTSTAGE" \
      $GCCMELT_LASTSTAGE/warmelt-first.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-base.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-debug.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-macro.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normal.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normatch.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-genobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-outobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-hooks.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-modes.quicklybuilt \
      ""

  ## meltbuild_emit_source  melt-build-script.tpl:463/348 base warmelt-modes
  meltbuild_info melt-build-script.tpl:464/349 generating C code of warmelt-modes in meltbuild-sources
  meltbuild_emit melt-build-script.tpl:465/350 \
      translatefile \
      warmelt-modes \
      meltbuild-sources \
      "$GCCMELT_LASTSTAGE" \
      $GCCMELT_LASTSTAGE/warmelt-first.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-base.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-debug.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-macro.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normal.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-normatch.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-genobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-outobj.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-hooks.quicklybuilt:$GCCMELT_LASTSTAGE/warmelt-modes.quicklybuilt \
      ""

}  # end of function meltbuild_emit_translator_sources


################
function meltbuild_compile_translator_modules () {


  # in meltbuild_compile_translator_sources quicklybuilt melt-build-script.tpl:480/351
  meltbuild_info melt-build-script.tpl:481/352 compiling translator quicklybuilt


   #@ melt-build-script.tpl:484/353 flavor quicklybuilt base warmelt-first
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/354 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=quicklybuilt \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-first \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-first \
 || meltbuild_error  melt-build-script.tpl:493/355 in meltbuild-modules failed to compile translator warmelt-first quicklybuilt make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/356 flavor quicklybuilt base warmelt-base
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/357 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=quicklybuilt \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-base \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-base \
 || meltbuild_error  melt-build-script.tpl:493/358 in meltbuild-modules failed to compile translator warmelt-base quicklybuilt make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/359 flavor quicklybuilt base warmelt-debug
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/360 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=quicklybuilt \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-debug \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-debug \
 || meltbuild_error  melt-build-script.tpl:493/361 in meltbuild-modules failed to compile translator warmelt-debug quicklybuilt make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/362 flavor quicklybuilt base warmelt-macro
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/363 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=quicklybuilt \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-macro \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-macro \
 || meltbuild_error  melt-build-script.tpl:493/364 in meltbuild-modules failed to compile translator warmelt-macro quicklybuilt make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/365 flavor quicklybuilt base warmelt-normal
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/366 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=quicklybuilt \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-normal \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-normal \
 || meltbuild_error  melt-build-script.tpl:493/367 in meltbuild-modules failed to compile translator warmelt-normal quicklybuilt make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/368 flavor quicklybuilt base warmelt-normatch
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/369 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=quicklybuilt \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-normatch \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-normatch \
 || meltbuild_error  melt-build-script.tpl:493/370 in meltbuild-modules failed to compile translator warmelt-normatch quicklybuilt make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/371 flavor quicklybuilt base warmelt-genobj
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/372 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=quicklybuilt \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-genobj \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-genobj \
 || meltbuild_error  melt-build-script.tpl:493/373 in meltbuild-modules failed to compile translator warmelt-genobj quicklybuilt make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/374 flavor quicklybuilt base warmelt-outobj
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/375 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=quicklybuilt \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-outobj \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-outobj \
 || meltbuild_error  melt-build-script.tpl:493/376 in meltbuild-modules failed to compile translator warmelt-outobj quicklybuilt make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/377 flavor quicklybuilt base warmelt-hooks
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/378 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=quicklybuilt \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-hooks \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-hooks \
 || meltbuild_error  melt-build-script.tpl:493/379 in meltbuild-modules failed to compile translator warmelt-hooks quicklybuilt make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/380 flavor quicklybuilt base warmelt-modes
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/381 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=quicklybuilt \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-modes \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-modes \
 || meltbuild_error  melt-build-script.tpl:493/382 in meltbuild-modules failed to compile translator warmelt-modes quicklybuilt make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS




  # in meltbuild_compile_translator_sources optimized melt-build-script.tpl:480/383
  meltbuild_info melt-build-script.tpl:481/384 compiling translator optimized


   #@ melt-build-script.tpl:484/385 flavor optimized base warmelt-first
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/386 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=optimized \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-first \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-first \
 || meltbuild_error  melt-build-script.tpl:493/387 in meltbuild-modules failed to compile translator warmelt-first optimized make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/388 flavor optimized base warmelt-base
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/389 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=optimized \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-base \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-base \
 || meltbuild_error  melt-build-script.tpl:493/390 in meltbuild-modules failed to compile translator warmelt-base optimized make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/391 flavor optimized base warmelt-debug
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/392 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=optimized \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-debug \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-debug \
 || meltbuild_error  melt-build-script.tpl:493/393 in meltbuild-modules failed to compile translator warmelt-debug optimized make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/394 flavor optimized base warmelt-macro
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/395 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=optimized \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-macro \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-macro \
 || meltbuild_error  melt-build-script.tpl:493/396 in meltbuild-modules failed to compile translator warmelt-macro optimized make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/397 flavor optimized base warmelt-normal
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/398 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=optimized \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-normal \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-normal \
 || meltbuild_error  melt-build-script.tpl:493/399 in meltbuild-modules failed to compile translator warmelt-normal optimized make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/400 flavor optimized base warmelt-normatch
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/401 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=optimized \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-normatch \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-normatch \
 || meltbuild_error  melt-build-script.tpl:493/402 in meltbuild-modules failed to compile translator warmelt-normatch optimized make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/403 flavor optimized base warmelt-genobj
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/404 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=optimized \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-genobj \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-genobj \
 || meltbuild_error  melt-build-script.tpl:493/405 in meltbuild-modules failed to compile translator warmelt-genobj optimized make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/406 flavor optimized base warmelt-outobj
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/407 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=optimized \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-outobj \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-outobj \
 || meltbuild_error  melt-build-script.tpl:493/408 in meltbuild-modules failed to compile translator warmelt-outobj optimized make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/409 flavor optimized base warmelt-hooks
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/410 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=optimized \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-hooks \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-hooks \
 || meltbuild_error  melt-build-script.tpl:493/411 in meltbuild-modules failed to compile translator warmelt-hooks optimized make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/412 flavor optimized base warmelt-modes
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/413 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=optimized \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-modes \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-modes \
 || meltbuild_error  melt-build-script.tpl:493/414 in meltbuild-modules failed to compile translator warmelt-modes optimized make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS




  # in meltbuild_compile_translator_sources debugnoline melt-build-script.tpl:480/415
  meltbuild_info melt-build-script.tpl:481/416 compiling translator debugnoline


   #@ melt-build-script.tpl:484/417 flavor debugnoline base warmelt-first
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/418 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=debugnoline \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-first \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-first \
 || meltbuild_error  melt-build-script.tpl:493/419 in meltbuild-modules failed to compile translator warmelt-first debugnoline make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/420 flavor debugnoline base warmelt-base
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/421 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=debugnoline \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-base \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-base \
 || meltbuild_error  melt-build-script.tpl:493/422 in meltbuild-modules failed to compile translator warmelt-base debugnoline make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/423 flavor debugnoline base warmelt-debug
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/424 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=debugnoline \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-debug \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-debug \
 || meltbuild_error  melt-build-script.tpl:493/425 in meltbuild-modules failed to compile translator warmelt-debug debugnoline make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/426 flavor debugnoline base warmelt-macro
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/427 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=debugnoline \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-macro \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-macro \
 || meltbuild_error  melt-build-script.tpl:493/428 in meltbuild-modules failed to compile translator warmelt-macro debugnoline make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/429 flavor debugnoline base warmelt-normal
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/430 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=debugnoline \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-normal \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-normal \
 || meltbuild_error  melt-build-script.tpl:493/431 in meltbuild-modules failed to compile translator warmelt-normal debugnoline make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/432 flavor debugnoline base warmelt-normatch
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/433 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=debugnoline \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-normatch \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-normatch \
 || meltbuild_error  melt-build-script.tpl:493/434 in meltbuild-modules failed to compile translator warmelt-normatch debugnoline make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/435 flavor debugnoline base warmelt-genobj
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/436 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=debugnoline \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-genobj \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-genobj \
 || meltbuild_error  melt-build-script.tpl:493/437 in meltbuild-modules failed to compile translator warmelt-genobj debugnoline make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/438 flavor debugnoline base warmelt-outobj
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/439 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=debugnoline \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-outobj \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-outobj \
 || meltbuild_error  melt-build-script.tpl:493/440 in meltbuild-modules failed to compile translator warmelt-outobj debugnoline make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/441 flavor debugnoline base warmelt-hooks
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/442 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=debugnoline \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-hooks \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-hooks \
 || meltbuild_error  melt-build-script.tpl:493/443 in meltbuild-modules failed to compile translator warmelt-hooks debugnoline make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS

   #@ melt-build-script.tpl:484/444 flavor debugnoline base warmelt-modes
   $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
     GCCMELT_FROM=melt-build-script.tpl:486/445 \
     GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
     GCCMELT_MODULE_FLAVOR=debugnoline \
     GCCMELT_COMPILER="$GCCMELT_COMPILER" \
     GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
     GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/warmelt-modes \
     GCCMELT_MODULE_BINARYBASE=meltbuild-modules/warmelt-modes \
 || meltbuild_error  melt-build-script.tpl:493/446 in meltbuild-modules failed to compile translator warmelt-modes debugnoline make "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler "$GCCMELT_COMPILER" cflags $GCCMELT_COMPILER_FLAGS



}     # end of function meltbuild_compile_translator_modules
################################################################


#################@ melt-build-script.tpl:501/447 
function meltbuild_symlink_melt_translator_sources () {


### symlinking the MELT translator code in meltbuild-sources for warmelt-first from melt-build-script.tpl:506/448

meltbuild_info melt-build-script.tpl:508/449 putting MELT translator code of warmelt-first in meltbuild-sources

meltbuild_symlink $GCCMELT_MELTSOURCEDIR/warmelt-first.melt meltbuild-sources/warmelt-first.melt




### symlinking the MELT translator code in meltbuild-sources for warmelt-base from melt-build-script.tpl:506/450

meltbuild_info melt-build-script.tpl:508/451 putting MELT translator code of warmelt-base in meltbuild-sources

meltbuild_symlink $GCCMELT_MELTSOURCEDIR/warmelt-base.melt meltbuild-sources/warmelt-base.melt




### symlinking the MELT translator code in meltbuild-sources for warmelt-debug from melt-build-script.tpl:506/452

meltbuild_info melt-build-script.tpl:508/453 putting MELT translator code of warmelt-debug in meltbuild-sources

meltbuild_symlink $GCCMELT_MELTSOURCEDIR/warmelt-debug.melt meltbuild-sources/warmelt-debug.melt




### symlinking the MELT translator code in meltbuild-sources for warmelt-macro from melt-build-script.tpl:506/454

meltbuild_info melt-build-script.tpl:508/455 putting MELT translator code of warmelt-macro in meltbuild-sources

meltbuild_symlink $GCCMELT_MELTSOURCEDIR/warmelt-macro.melt meltbuild-sources/warmelt-macro.melt




### symlinking the MELT translator code in meltbuild-sources for warmelt-normal from melt-build-script.tpl:506/456

meltbuild_info melt-build-script.tpl:508/457 putting MELT translator code of warmelt-normal in meltbuild-sources

meltbuild_symlink $GCCMELT_MELTSOURCEDIR/warmelt-normal.melt meltbuild-sources/warmelt-normal.melt
meltbuild_symlink warmelt-predef.melt meltbuild-sources/warmelt-predef.melt



### symlinking the MELT translator code in meltbuild-sources for warmelt-normatch from melt-build-script.tpl:506/458

meltbuild_info melt-build-script.tpl:508/459 putting MELT translator code of warmelt-normatch in meltbuild-sources

meltbuild_symlink $GCCMELT_MELTSOURCEDIR/warmelt-normatch.melt meltbuild-sources/warmelt-normatch.melt




### symlinking the MELT translator code in meltbuild-sources for warmelt-genobj from melt-build-script.tpl:506/460

meltbuild_info melt-build-script.tpl:508/461 putting MELT translator code of warmelt-genobj in meltbuild-sources

meltbuild_symlink $GCCMELT_MELTSOURCEDIR/warmelt-genobj.melt meltbuild-sources/warmelt-genobj.melt




### symlinking the MELT translator code in meltbuild-sources for warmelt-outobj from melt-build-script.tpl:506/462

meltbuild_info melt-build-script.tpl:508/463 putting MELT translator code of warmelt-outobj in meltbuild-sources

meltbuild_symlink $GCCMELT_MELTSOURCEDIR/warmelt-outobj.melt meltbuild-sources/warmelt-outobj.melt




### symlinking the MELT translator code in meltbuild-sources for warmelt-hooks from melt-build-script.tpl:506/464

meltbuild_info melt-build-script.tpl:508/465 putting MELT translator code of warmelt-hooks in meltbuild-sources

meltbuild_symlink $GCCMELT_MELTSOURCEDIR/warmelt-hooks.melt meltbuild-sources/warmelt-hooks.melt




### symlinking the MELT translator code in meltbuild-sources for warmelt-modes from melt-build-script.tpl:506/466

meltbuild_info melt-build-script.tpl:508/467 putting MELT translator code of warmelt-modes in meltbuild-sources

meltbuild_symlink $GCCMELT_MELTSOURCEDIR/warmelt-modes.melt meltbuild-sources/warmelt-modes.melt



} 				# end of meltbuild_symlink_melt_translator_sources


################@ melt-build-script.tpl:517/468 
melt_final_translator_stamp=meltbuild-final-translator.stamp

if [ ! -f $melt_final_translator_stamp -o $melt_final_translator_stamp -ot $GCCMELT_RUNTIME_DEPENDENCY \
 -o $melt_final_translator_stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-first.melt \
 -o $melt_final_translator_stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-base.melt \
 -o $melt_final_translator_stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-debug.melt \
 -o $melt_final_translator_stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-macro.melt \
 -o $melt_final_translator_stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-normal.melt \
 -o $melt_final_translator_stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-normatch.melt \
 -o $melt_final_translator_stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-genobj.melt \
 -o $melt_final_translator_stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-outobj.melt \
 -o $melt_final_translator_stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-hooks.melt \
 -o $melt_final_translator_stamp -ot $GCCMELT_MELTSOURCEDIR/warmelt-modes.melt \
 -o $melt_final_translator_stamp -ot $GCCMELT_LASTSTAGE/$GCCMELT_LASTSTAGE.stamp ]; then
    meltbuild_notice 'Emit Translator Source'  melt-build-script.tpl:523/469 emit then translate the MELT translator 
    meltbuild_info melt-build-script.tpl:524/470 emit then translate the compile translator for  $melt_final_translator_stamp
    meltbuild_emit_translator_sources
    meltbuild_symlink_melt_translator_sources
    meltbuild_compile_translator_modules
    melt_final_translator_stamptemp=$melt_final_translator_stamp-tmp$$
    echo "///MELT translator timestamp file $melt_final_translator_stamp" > $melt_final_translator_stamptemp
    echo $GCCMELT_RUNTIME_DEPENDENCY_MD5SUM $GCCMELT_RUNTIME_DEPENDENCY >>  $melt_final_translator_stamptemp

#@  melt-build-script.tpl:532/471 
    $MD5SUM meltbuild-sources/warmelt-first.melt  >>  $melt_final_translator_stamptemp
  
    $MD5SUM meltbuild-sources/warmelt-first.c meltbuild-sources/warmelt-first+[0-9][0-9].c  >> $melt_final_translator_stamptemp
    melt_translator_FIRST_cumulmd5=$(cat  meltbuild-sources/warmelt-first.c meltbuild-sources/warmelt-first+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)

#@  melt-build-script.tpl:532/472 
    $MD5SUM meltbuild-sources/warmelt-base.melt  >>  $melt_final_translator_stamptemp
  
    $MD5SUM meltbuild-sources/warmelt-base.c meltbuild-sources/warmelt-base+[0-9][0-9].c  >> $melt_final_translator_stamptemp
    melt_translator_BASE_cumulmd5=$(cat  meltbuild-sources/warmelt-base.c meltbuild-sources/warmelt-base+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)

#@  melt-build-script.tpl:532/473 
    $MD5SUM meltbuild-sources/warmelt-debug.melt  >>  $melt_final_translator_stamptemp
  
    $MD5SUM meltbuild-sources/warmelt-debug.c meltbuild-sources/warmelt-debug+[0-9][0-9].c  >> $melt_final_translator_stamptemp
    melt_translator_DEBUG_cumulmd5=$(cat  meltbuild-sources/warmelt-debug.c meltbuild-sources/warmelt-debug+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)

#@  melt-build-script.tpl:532/474 
    $MD5SUM meltbuild-sources/warmelt-macro.melt  >>  $melt_final_translator_stamptemp
  
    $MD5SUM meltbuild-sources/warmelt-macro.c meltbuild-sources/warmelt-macro+[0-9][0-9].c  >> $melt_final_translator_stamptemp
    melt_translator_MACRO_cumulmd5=$(cat  meltbuild-sources/warmelt-macro.c meltbuild-sources/warmelt-macro+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)

#@  melt-build-script.tpl:532/475 
    $MD5SUM meltbuild-sources/warmelt-normal.melt  >>  $melt_final_translator_stamptemp
  
    $MD5SUM meltbuild-sources/warmelt-predef.melt  >>  $melt_final_translator_stamptemp
  
    $MD5SUM meltbuild-sources/warmelt-normal.c meltbuild-sources/warmelt-normal+[0-9][0-9].c  >> $melt_final_translator_stamptemp
    melt_translator_NORMAL_cumulmd5=$(cat  meltbuild-sources/warmelt-normal.c meltbuild-sources/warmelt-normal+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)

#@  melt-build-script.tpl:532/476 
    $MD5SUM meltbuild-sources/warmelt-normatch.melt  >>  $melt_final_translator_stamptemp
  
    $MD5SUM meltbuild-sources/warmelt-normatch.c meltbuild-sources/warmelt-normatch+[0-9][0-9].c  >> $melt_final_translator_stamptemp
    melt_translator_NORMATCH_cumulmd5=$(cat  meltbuild-sources/warmelt-normatch.c meltbuild-sources/warmelt-normatch+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)

#@  melt-build-script.tpl:532/477 
    $MD5SUM meltbuild-sources/warmelt-genobj.melt  >>  $melt_final_translator_stamptemp
  
    $MD5SUM meltbuild-sources/warmelt-genobj.c meltbuild-sources/warmelt-genobj+[0-9][0-9].c  >> $melt_final_translator_stamptemp
    melt_translator_GENOBJ_cumulmd5=$(cat  meltbuild-sources/warmelt-genobj.c meltbuild-sources/warmelt-genobj+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)

#@  melt-build-script.tpl:532/478 
    $MD5SUM meltbuild-sources/warmelt-outobj.melt  >>  $melt_final_translator_stamptemp
  
    $MD5SUM meltbuild-sources/warmelt-outobj.c meltbuild-sources/warmelt-outobj+[0-9][0-9].c  >> $melt_final_translator_stamptemp
    melt_translator_OUTOBJ_cumulmd5=$(cat  meltbuild-sources/warmelt-outobj.c meltbuild-sources/warmelt-outobj+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)

#@  melt-build-script.tpl:532/479 
    $MD5SUM meltbuild-sources/warmelt-hooks.melt  >>  $melt_final_translator_stamptemp
  
    $MD5SUM meltbuild-sources/warmelt-hooks.c meltbuild-sources/warmelt-hooks+[0-9][0-9].c  >> $melt_final_translator_stamptemp
    melt_translator_HOOKS_cumulmd5=$(cat  meltbuild-sources/warmelt-hooks.c meltbuild-sources/warmelt-hooks+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)

#@  melt-build-script.tpl:532/480 
    $MD5SUM meltbuild-sources/warmelt-modes.melt  >>  $melt_final_translator_stamptemp
  
    $MD5SUM meltbuild-sources/warmelt-modes.c meltbuild-sources/warmelt-modes+[0-9][0-9].c  >> $melt_final_translator_stamptemp
    melt_translator_MODES_cumulmd5=$(cat  meltbuild-sources/warmelt-modes.c meltbuild-sources/warmelt-modes+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)

    echo "///end timestamp file $melt_final_translator_stamp"
    $GCCMELT_MOVE_IF_CHANGE $melt_final_translator_stamptemp $melt_final_translator_stamp
else
    meltbuild_info melt-build-script.tpl:543/481 skip final translation of translator stamp  $melt_final_translator_stamp
fi

################################################################
#@ melt-build-script.tpl:547/482
if [ "$melt_overall_goal" = "translator" ]; then
    meltbuild_info melt-build-script.tpl:549/483 done translation overall goal with stamp  $melt_final_translator_stamp
    exit 0
fi

################
#@ melt-build-script.tpl:554/484 before application xtramelt* modules
################################################################
meltbuild_info melt-build-script.tpl:556/485 before applications GCCMELT_SKIPEMITC=$GCCMELT_SKIPEMITC.

meltbuild_info melt-build-script.tpl:558/486 times before applications at `date '+%x %H:%M:%S'`: ;  times >&2
 
melt_final_application_stamp=meltbuild-final-application.stamp

function meltbuild_do_applications () {
meltbuild_notice 'doing applications'  melt-build-script.tpl:563/487 doing applications 



  ## meltbuild_do_applications xtramelt-ana-base melt-build-script.tpl:567/488
  if [ ! -f meltbuild-sources/xtramelt-ana-base.melt ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/xtramelt-ana-base.melt meltbuild-sources/xtramelt-ana-base.melt
  fi
  ## meltbuild_do_applications xtramelt-ana-base melt-build-script.tpl:571/489
  if [ ! -f meltbuild-sources/xtramelt-ana-base.c -o  ! -f meltbuild-sources/xtramelt-ana-base+meltdesc.c \
       -o meltbuild-sources/xtramelt-ana-base+meltdesc.c -ot meltbuild-final-translator.stamp \
       -o meltbuild-sources/xtramelt-ana-base+meltdesc.c -ot  meltbuild-sources/xtramelt-ana-base.melt \
 ]; then
      meltbuild_info melt-build-script.tpl:577/490 emit application C code for xtramelt-ana-base
      meltbuild_emit melt-build-script.tpl:578/491 \
	  translatefile \
	  xtramelt-ana-base \
	  meltbuild-sources \
	  meltbuild-modules \
	  warmelt-first.optimized:warmelt-base.optimized:warmelt-debug.optimized:warmelt-macro.optimized:warmelt-normal.optimized:warmelt-normatch.optimized:warmelt-genobj.optimized:warmelt-outobj.optimized:warmelt-hooks.optimized:warmelt-modes.optimized \
    "" \
	  || meltbuild_error melt-build-script.tpl:585/492 failed to generate C code of application xtramelt-ana-base
  else
      meltbuild_info melt-build-script.tpl:587/493 DONT emit application C code for xtramelt-ana-base
  fi
  local meltapp_ANA_BASE_cumulmd5=$(cat  meltbuild-sources/xtramelt-ana-base.c meltbuild-sources/xtramelt-ana-base+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)
 
  if [ ! -f meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.quicklybuilt.so \
      -o meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.quicklybuilt.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-ana-base.c \
      -o  meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-ana-base+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/494 compiling application module for xtramelt-ana-base quicklybuilt
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/495 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=quicklybuilt \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-base \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-base \
	  || meltbuild_error  melt-build-script.tpl:604/496 in meltbuild-modules failed to compile application xtramelt-ana-base quicklybuilt "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/497 not compiling application module for xtramelt-ana-base quicklybuilt
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.optimized.so \
      -o meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.optimized.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-ana-base.c \
      -o  meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-ana-base+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/498 compiling application module for xtramelt-ana-base optimized
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/499 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=optimized \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-base \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-base \
	  || meltbuild_error  melt-build-script.tpl:604/500 in meltbuild-modules failed to compile application xtramelt-ana-base optimized "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/501 not compiling application module for xtramelt-ana-base optimized
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.debugnoline.so \
      -o meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.debugnoline.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-ana-base.c \
      -o  meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-ana-base+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/502 compiling application module for xtramelt-ana-base debugnoline
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/503 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=debugnoline \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-base \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-base \
	  || meltbuild_error  melt-build-script.tpl:604/504 in meltbuild-modules failed to compile application xtramelt-ana-base debugnoline "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/505 not compiling application module for xtramelt-ana-base debugnoline
  fi
 


  ## meltbuild_do_applications xtramelt-ana-tree melt-build-script.tpl:567/506
  if [ ! -f meltbuild-sources/xtramelt-ana-tree.melt ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/xtramelt-ana-tree.melt meltbuild-sources/xtramelt-ana-tree.melt
  fi
  ## meltbuild_do_applications xtramelt-ana-tree melt-build-script.tpl:571/507
  if [ ! -f meltbuild-sources/xtramelt-ana-tree.c -o  ! -f meltbuild-sources/xtramelt-ana-tree+meltdesc.c \
       -o meltbuild-sources/xtramelt-ana-tree+meltdesc.c -ot meltbuild-final-translator.stamp \
       -o meltbuild-sources/xtramelt-ana-tree+meltdesc.c -ot  meltbuild-sources/xtramelt-ana-tree.melt \
 -o meltbuild-sources/xtramelt-ana-base+meltdesc.c -ot meltbuild-sources/xtramelt-ana-tree+meltdesc.c \
 ]; then
      meltbuild_info melt-build-script.tpl:577/508 emit application C code for xtramelt-ana-tree
      meltbuild_emit melt-build-script.tpl:578/509 \
	  translatefile \
	  xtramelt-ana-tree \
	  meltbuild-sources \
	  meltbuild-modules \
	  warmelt-first.optimized:warmelt-base.optimized:warmelt-debug.optimized:warmelt-macro.optimized:warmelt-normal.optimized:warmelt-normatch.optimized:warmelt-genobj.optimized:warmelt-outobj.optimized:warmelt-hooks.optimized:warmelt-modes.optimized:xtramelt-ana-base.quicklybuilt \
    "" \
	  || meltbuild_error melt-build-script.tpl:585/510 failed to generate C code of application xtramelt-ana-tree
  else
      meltbuild_info melt-build-script.tpl:587/511 DONT emit application C code for xtramelt-ana-tree
  fi
  local meltapp_ANA_TREE_cumulmd5=$(cat  meltbuild-sources/xtramelt-ana-tree.c meltbuild-sources/xtramelt-ana-tree+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)
 
  if [ ! -f meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.quicklybuilt.so \
      -o meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.quicklybuilt.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-ana-tree.c \
      -o  meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-ana-tree+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/512 compiling application module for xtramelt-ana-tree quicklybuilt
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/513 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=quicklybuilt \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-tree \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-tree \
	  || meltbuild_error  melt-build-script.tpl:604/514 in meltbuild-modules failed to compile application xtramelt-ana-tree quicklybuilt "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/515 not compiling application module for xtramelt-ana-tree quicklybuilt
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.optimized.so \
      -o meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.optimized.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-ana-tree.c \
      -o  meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-ana-tree+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/516 compiling application module for xtramelt-ana-tree optimized
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/517 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=optimized \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-tree \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-tree \
	  || meltbuild_error  melt-build-script.tpl:604/518 in meltbuild-modules failed to compile application xtramelt-ana-tree optimized "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/519 not compiling application module for xtramelt-ana-tree optimized
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.debugnoline.so \
      -o meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.debugnoline.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-ana-tree.c \
      -o  meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-ana-tree+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/520 compiling application module for xtramelt-ana-tree debugnoline
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/521 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=debugnoline \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-tree \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-tree \
	  || meltbuild_error  melt-build-script.tpl:604/522 in meltbuild-modules failed to compile application xtramelt-ana-tree debugnoline "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/523 not compiling application module for xtramelt-ana-tree debugnoline
  fi
 


  ## meltbuild_do_applications xtramelt-ana-gimple melt-build-script.tpl:567/524
  if [ ! -f meltbuild-sources/xtramelt-ana-gimple.melt ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/xtramelt-ana-gimple.melt meltbuild-sources/xtramelt-ana-gimple.melt
  fi
  ## meltbuild_do_applications xtramelt-ana-gimple melt-build-script.tpl:571/525
  if [ ! -f meltbuild-sources/xtramelt-ana-gimple.c -o  ! -f meltbuild-sources/xtramelt-ana-gimple+meltdesc.c \
       -o meltbuild-sources/xtramelt-ana-gimple+meltdesc.c -ot meltbuild-final-translator.stamp \
       -o meltbuild-sources/xtramelt-ana-gimple+meltdesc.c -ot  meltbuild-sources/xtramelt-ana-gimple.melt \
 -o meltbuild-sources/xtramelt-ana-base+meltdesc.c -ot meltbuild-sources/xtramelt-ana-gimple+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-tree+meltdesc.c -ot meltbuild-sources/xtramelt-ana-gimple+meltdesc.c \
 ]; then
      meltbuild_info melt-build-script.tpl:577/526 emit application C code for xtramelt-ana-gimple
      meltbuild_emit melt-build-script.tpl:578/527 \
	  translatefile \
	  xtramelt-ana-gimple \
	  meltbuild-sources \
	  meltbuild-modules \
	  warmelt-first.optimized:warmelt-base.optimized:warmelt-debug.optimized:warmelt-macro.optimized:warmelt-normal.optimized:warmelt-normatch.optimized:warmelt-genobj.optimized:warmelt-outobj.optimized:warmelt-hooks.optimized:warmelt-modes.optimized:xtramelt-ana-base.quicklybuilt:xtramelt-ana-tree.quicklybuilt \
    "" \
	  || meltbuild_error melt-build-script.tpl:585/528 failed to generate C code of application xtramelt-ana-gimple
  else
      meltbuild_info melt-build-script.tpl:587/529 DONT emit application C code for xtramelt-ana-gimple
  fi
  local meltapp_ANA_GIMPLE_cumulmd5=$(cat  meltbuild-sources/xtramelt-ana-gimple.c meltbuild-sources/xtramelt-ana-gimple+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)
 
  if [ ! -f meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.quicklybuilt.so \
      -o meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.quicklybuilt.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-ana-gimple.c \
      -o  meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-ana-gimple+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/530 compiling application module for xtramelt-ana-gimple quicklybuilt
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/531 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=quicklybuilt \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-gimple \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-gimple \
	  || meltbuild_error  melt-build-script.tpl:604/532 in meltbuild-modules failed to compile application xtramelt-ana-gimple quicklybuilt "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/533 not compiling application module for xtramelt-ana-gimple quicklybuilt
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.optimized.so \
      -o meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.optimized.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-ana-gimple.c \
      -o  meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-ana-gimple+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/534 compiling application module for xtramelt-ana-gimple optimized
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/535 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=optimized \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-gimple \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-gimple \
	  || meltbuild_error  melt-build-script.tpl:604/536 in meltbuild-modules failed to compile application xtramelt-ana-gimple optimized "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/537 not compiling application module for xtramelt-ana-gimple optimized
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.debugnoline.so \
      -o meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.debugnoline.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-ana-gimple.c \
      -o  meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-ana-gimple+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/538 compiling application module for xtramelt-ana-gimple debugnoline
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/539 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=debugnoline \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-gimple \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-gimple \
	  || meltbuild_error  melt-build-script.tpl:604/540 in meltbuild-modules failed to compile application xtramelt-ana-gimple debugnoline "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/541 not compiling application module for xtramelt-ana-gimple debugnoline
  fi
 


  ## meltbuild_do_applications xtramelt-probe melt-build-script.tpl:567/542
  if [ ! -f meltbuild-sources/xtramelt-probe.melt ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/xtramelt-probe.melt meltbuild-sources/xtramelt-probe.melt
  fi
  ## meltbuild_do_applications xtramelt-probe melt-build-script.tpl:571/543
  if [ ! -f meltbuild-sources/xtramelt-probe.c -o  ! -f meltbuild-sources/xtramelt-probe+meltdesc.c \
       -o meltbuild-sources/xtramelt-probe+meltdesc.c -ot meltbuild-final-translator.stamp \
       -o meltbuild-sources/xtramelt-probe+meltdesc.c -ot  meltbuild-sources/xtramelt-probe.melt \
 -o meltbuild-sources/xtramelt-ana-base+meltdesc.c -ot meltbuild-sources/xtramelt-probe+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-tree+meltdesc.c -ot meltbuild-sources/xtramelt-probe+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-gimple+meltdesc.c -ot meltbuild-sources/xtramelt-probe+meltdesc.c \
 ]; then
      meltbuild_info melt-build-script.tpl:577/544 emit application C code for xtramelt-probe
      meltbuild_emit melt-build-script.tpl:578/545 \
	  translatefile \
	  xtramelt-probe \
	  meltbuild-sources \
	  meltbuild-modules \
	  warmelt-first.optimized:warmelt-base.optimized:warmelt-debug.optimized:warmelt-macro.optimized:warmelt-normal.optimized:warmelt-normatch.optimized:warmelt-genobj.optimized:warmelt-outobj.optimized:warmelt-hooks.optimized:warmelt-modes.optimized:xtramelt-ana-base.quicklybuilt:xtramelt-ana-tree.quicklybuilt:xtramelt-ana-gimple.quicklybuilt \
    "" \
	  || meltbuild_error melt-build-script.tpl:585/546 failed to generate C code of application xtramelt-probe
  else
      meltbuild_info melt-build-script.tpl:587/547 DONT emit application C code for xtramelt-probe
  fi
  local meltapp_PROBE_cumulmd5=$(cat  meltbuild-sources/xtramelt-probe.c meltbuild-sources/xtramelt-probe+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)
 
  if [ ! -f meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.quicklybuilt.so \
      -o meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.quicklybuilt.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-probe.c \
      -o  meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-probe+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/548 compiling application module for xtramelt-probe quicklybuilt
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/549 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=quicklybuilt \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-probe \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-probe \
	  || meltbuild_error  melt-build-script.tpl:604/550 in meltbuild-modules failed to compile application xtramelt-probe quicklybuilt "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/551 not compiling application module for xtramelt-probe quicklybuilt
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.optimized.so \
      -o meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.optimized.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-probe.c \
      -o  meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-probe+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/552 compiling application module for xtramelt-probe optimized
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/553 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=optimized \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-probe \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-probe \
	  || meltbuild_error  melt-build-script.tpl:604/554 in meltbuild-modules failed to compile application xtramelt-probe optimized "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/555 not compiling application module for xtramelt-probe optimized
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.debugnoline.so \
      -o meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.debugnoline.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-probe.c \
      -o  meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-probe+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/556 compiling application module for xtramelt-probe debugnoline
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/557 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=debugnoline \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-probe \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-probe \
	  || meltbuild_error  melt-build-script.tpl:604/558 in meltbuild-modules failed to compile application xtramelt-probe debugnoline "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/559 not compiling application module for xtramelt-probe debugnoline
  fi
 


  ## meltbuild_do_applications xtramelt-ana-simple melt-build-script.tpl:567/560
  if [ ! -f meltbuild-sources/xtramelt-ana-simple.melt ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/xtramelt-ana-simple.melt meltbuild-sources/xtramelt-ana-simple.melt
  fi
  ## meltbuild_do_applications xtramelt-ana-simple melt-build-script.tpl:571/561
  if [ ! -f meltbuild-sources/xtramelt-ana-simple.c -o  ! -f meltbuild-sources/xtramelt-ana-simple+meltdesc.c \
       -o meltbuild-sources/xtramelt-ana-simple+meltdesc.c -ot meltbuild-final-translator.stamp \
       -o meltbuild-sources/xtramelt-ana-simple+meltdesc.c -ot  meltbuild-sources/xtramelt-ana-simple.melt \
 -o meltbuild-sources/xtramelt-ana-base+meltdesc.c -ot meltbuild-sources/xtramelt-ana-simple+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-tree+meltdesc.c -ot meltbuild-sources/xtramelt-ana-simple+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-gimple+meltdesc.c -ot meltbuild-sources/xtramelt-ana-simple+meltdesc.c \
 -o meltbuild-sources/xtramelt-probe+meltdesc.c -ot meltbuild-sources/xtramelt-ana-simple+meltdesc.c \
 ]; then
      meltbuild_info melt-build-script.tpl:577/562 emit application C code for xtramelt-ana-simple
      meltbuild_emit melt-build-script.tpl:578/563 \
	  translatefile \
	  xtramelt-ana-simple \
	  meltbuild-sources \
	  meltbuild-modules \
	  warmelt-first.optimized:warmelt-base.optimized:warmelt-debug.optimized:warmelt-macro.optimized:warmelt-normal.optimized:warmelt-normatch.optimized:warmelt-genobj.optimized:warmelt-outobj.optimized:warmelt-hooks.optimized:warmelt-modes.optimized:xtramelt-ana-base.quicklybuilt:xtramelt-ana-tree.quicklybuilt:xtramelt-ana-gimple.quicklybuilt:xtramelt-probe.quicklybuilt \
    "" \
	  || meltbuild_error melt-build-script.tpl:585/564 failed to generate C code of application xtramelt-ana-simple
  else
      meltbuild_info melt-build-script.tpl:587/565 DONT emit application C code for xtramelt-ana-simple
  fi
  local meltapp_ANA_SIMPLE_cumulmd5=$(cat  meltbuild-sources/xtramelt-ana-simple.c meltbuild-sources/xtramelt-ana-simple+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)
 
  if [ ! -f meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.quicklybuilt.so \
      -o meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.quicklybuilt.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-ana-simple.c \
      -o  meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-ana-simple+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/566 compiling application module for xtramelt-ana-simple quicklybuilt
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/567 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=quicklybuilt \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-simple \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-simple \
	  || meltbuild_error  melt-build-script.tpl:604/568 in meltbuild-modules failed to compile application xtramelt-ana-simple quicklybuilt "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/569 not compiling application module for xtramelt-ana-simple quicklybuilt
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.optimized.so \
      -o meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.optimized.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-ana-simple.c \
      -o  meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-ana-simple+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/570 compiling application module for xtramelt-ana-simple optimized
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/571 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=optimized \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-simple \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-simple \
	  || meltbuild_error  melt-build-script.tpl:604/572 in meltbuild-modules failed to compile application xtramelt-ana-simple optimized "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/573 not compiling application module for xtramelt-ana-simple optimized
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.debugnoline.so \
      -o meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.debugnoline.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-ana-simple.c \
      -o  meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-ana-simple+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/574 compiling application module for xtramelt-ana-simple debugnoline
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/575 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=debugnoline \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-ana-simple \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-ana-simple \
	  || meltbuild_error  melt-build-script.tpl:604/576 in meltbuild-modules failed to compile application xtramelt-ana-simple debugnoline "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/577 not compiling application module for xtramelt-ana-simple debugnoline
  fi
 


  ## meltbuild_do_applications xtramelt-c-generator melt-build-script.tpl:567/578
  if [ ! -f meltbuild-sources/xtramelt-c-generator.melt ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/xtramelt-c-generator.melt meltbuild-sources/xtramelt-c-generator.melt
  fi
  ## meltbuild_do_applications xtramelt-c-generator melt-build-script.tpl:571/579
  if [ ! -f meltbuild-sources/xtramelt-c-generator.c -o  ! -f meltbuild-sources/xtramelt-c-generator+meltdesc.c \
       -o meltbuild-sources/xtramelt-c-generator+meltdesc.c -ot meltbuild-final-translator.stamp \
       -o meltbuild-sources/xtramelt-c-generator+meltdesc.c -ot  meltbuild-sources/xtramelt-c-generator.melt \
 -o meltbuild-sources/xtramelt-ana-base+meltdesc.c -ot meltbuild-sources/xtramelt-c-generator+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-tree+meltdesc.c -ot meltbuild-sources/xtramelt-c-generator+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-gimple+meltdesc.c -ot meltbuild-sources/xtramelt-c-generator+meltdesc.c \
 -o meltbuild-sources/xtramelt-probe+meltdesc.c -ot meltbuild-sources/xtramelt-c-generator+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-simple+meltdesc.c -ot meltbuild-sources/xtramelt-c-generator+meltdesc.c \
 ]; then
      meltbuild_info melt-build-script.tpl:577/580 emit application C code for xtramelt-c-generator
      meltbuild_emit melt-build-script.tpl:578/581 \
	  translatefile \
	  xtramelt-c-generator \
	  meltbuild-sources \
	  meltbuild-modules \
	  warmelt-first.optimized:warmelt-base.optimized:warmelt-debug.optimized:warmelt-macro.optimized:warmelt-normal.optimized:warmelt-normatch.optimized:warmelt-genobj.optimized:warmelt-outobj.optimized:warmelt-hooks.optimized:warmelt-modes.optimized:xtramelt-ana-base.quicklybuilt:xtramelt-ana-tree.quicklybuilt:xtramelt-ana-gimple.quicklybuilt:xtramelt-probe.quicklybuilt:xtramelt-ana-simple.quicklybuilt \
    "" \
	  || meltbuild_error melt-build-script.tpl:585/582 failed to generate C code of application xtramelt-c-generator
  else
      meltbuild_info melt-build-script.tpl:587/583 DONT emit application C code for xtramelt-c-generator
  fi
  local meltapp_C_GENERATOR_cumulmd5=$(cat  meltbuild-sources/xtramelt-c-generator.c meltbuild-sources/xtramelt-c-generator+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)
 
  if [ ! -f meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.quicklybuilt.so \
      -o meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.quicklybuilt.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-c-generator.c \
      -o  meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-c-generator+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/584 compiling application module for xtramelt-c-generator quicklybuilt
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/585 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=quicklybuilt \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-c-generator \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-c-generator \
	  || meltbuild_error  melt-build-script.tpl:604/586 in meltbuild-modules failed to compile application xtramelt-c-generator quicklybuilt "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/587 not compiling application module for xtramelt-c-generator quicklybuilt
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.optimized.so \
      -o meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.optimized.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-c-generator.c \
      -o  meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-c-generator+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/588 compiling application module for xtramelt-c-generator optimized
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/589 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=optimized \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-c-generator \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-c-generator \
	  || meltbuild_error  melt-build-script.tpl:604/590 in meltbuild-modules failed to compile application xtramelt-c-generator optimized "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/591 not compiling application module for xtramelt-c-generator optimized
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.debugnoline.so \
      -o meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.debugnoline.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-c-generator.c \
      -o  meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-c-generator+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/592 compiling application module for xtramelt-c-generator debugnoline
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/593 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=debugnoline \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-c-generator \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-c-generator \
	  || meltbuild_error  melt-build-script.tpl:604/594 in meltbuild-modules failed to compile application xtramelt-c-generator debugnoline "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/595 not compiling application module for xtramelt-c-generator debugnoline
  fi
 


  ## meltbuild_do_applications xtramelt-opengpu melt-build-script.tpl:567/596
  if [ ! -f meltbuild-sources/xtramelt-opengpu.melt ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/xtramelt-opengpu.melt meltbuild-sources/xtramelt-opengpu.melt
  fi
  ## meltbuild_do_applications xtramelt-opengpu melt-build-script.tpl:571/597
  if [ ! -f meltbuild-sources/xtramelt-opengpu.c -o  ! -f meltbuild-sources/xtramelt-opengpu+meltdesc.c \
       -o meltbuild-sources/xtramelt-opengpu+meltdesc.c -ot meltbuild-final-translator.stamp \
       -o meltbuild-sources/xtramelt-opengpu+meltdesc.c -ot  meltbuild-sources/xtramelt-opengpu.melt \
 -o meltbuild-sources/xtramelt-ana-base+meltdesc.c -ot meltbuild-sources/xtramelt-opengpu+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-tree+meltdesc.c -ot meltbuild-sources/xtramelt-opengpu+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-gimple+meltdesc.c -ot meltbuild-sources/xtramelt-opengpu+meltdesc.c \
 -o meltbuild-sources/xtramelt-probe+meltdesc.c -ot meltbuild-sources/xtramelt-opengpu+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-simple+meltdesc.c -ot meltbuild-sources/xtramelt-opengpu+meltdesc.c \
 -o meltbuild-sources/xtramelt-c-generator+meltdesc.c -ot meltbuild-sources/xtramelt-opengpu+meltdesc.c \
 ]; then
      meltbuild_info melt-build-script.tpl:577/598 emit application C code for xtramelt-opengpu
      meltbuild_emit melt-build-script.tpl:578/599 \
	  translatefile \
	  xtramelt-opengpu \
	  meltbuild-sources \
	  meltbuild-modules \
	  warmelt-first.optimized:warmelt-base.optimized:warmelt-debug.optimized:warmelt-macro.optimized:warmelt-normal.optimized:warmelt-normatch.optimized:warmelt-genobj.optimized:warmelt-outobj.optimized:warmelt-hooks.optimized:warmelt-modes.optimized:xtramelt-ana-base.quicklybuilt:xtramelt-ana-tree.quicklybuilt:xtramelt-ana-gimple.quicklybuilt:xtramelt-probe.quicklybuilt:xtramelt-ana-simple.quicklybuilt:xtramelt-c-generator.quicklybuilt \
    "" \
	  || meltbuild_error melt-build-script.tpl:585/600 failed to generate C code of application xtramelt-opengpu
  else
      meltbuild_info melt-build-script.tpl:587/601 DONT emit application C code for xtramelt-opengpu
  fi
  local meltapp_OPENGPU_cumulmd5=$(cat  meltbuild-sources/xtramelt-opengpu.c meltbuild-sources/xtramelt-opengpu+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)
 
  if [ ! -f meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.quicklybuilt.so \
      -o meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.quicklybuilt.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-opengpu.c \
      -o  meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-opengpu+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/602 compiling application module for xtramelt-opengpu quicklybuilt
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/603 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=quicklybuilt \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-opengpu \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-opengpu \
	  || meltbuild_error  melt-build-script.tpl:604/604 in meltbuild-modules failed to compile application xtramelt-opengpu quicklybuilt "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/605 not compiling application module for xtramelt-opengpu quicklybuilt
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.optimized.so \
      -o meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.optimized.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-opengpu.c \
      -o  meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-opengpu+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/606 compiling application module for xtramelt-opengpu optimized
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/607 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=optimized \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-opengpu \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-opengpu \
	  || meltbuild_error  melt-build-script.tpl:604/608 in meltbuild-modules failed to compile application xtramelt-opengpu optimized "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/609 not compiling application module for xtramelt-opengpu optimized
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.debugnoline.so \
      -o meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.debugnoline.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-opengpu.c \
      -o  meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-opengpu+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/610 compiling application module for xtramelt-opengpu debugnoline
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/611 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=debugnoline \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-opengpu \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-opengpu \
	  || meltbuild_error  melt-build-script.tpl:604/612 in meltbuild-modules failed to compile application xtramelt-opengpu debugnoline "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/613 not compiling application module for xtramelt-opengpu debugnoline
  fi
 


  ## meltbuild_do_applications xtramelt-playground melt-build-script.tpl:567/614
  if [ ! -f meltbuild-sources/xtramelt-playground.melt ]; then
      meltbuild_symlink $GCCMELT_MELTSOURCEDIR/xtramelt-playground.melt meltbuild-sources/xtramelt-playground.melt
  fi
  ## meltbuild_do_applications xtramelt-playground melt-build-script.tpl:571/615
  if [ ! -f meltbuild-sources/xtramelt-playground.c -o  ! -f meltbuild-sources/xtramelt-playground+meltdesc.c \
       -o meltbuild-sources/xtramelt-playground+meltdesc.c -ot meltbuild-final-translator.stamp \
       -o meltbuild-sources/xtramelt-playground+meltdesc.c -ot  meltbuild-sources/xtramelt-playground.melt \
 -o meltbuild-sources/xtramelt-ana-base+meltdesc.c -ot meltbuild-sources/xtramelt-playground+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-tree+meltdesc.c -ot meltbuild-sources/xtramelt-playground+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-gimple+meltdesc.c -ot meltbuild-sources/xtramelt-playground+meltdesc.c \
 -o meltbuild-sources/xtramelt-probe+meltdesc.c -ot meltbuild-sources/xtramelt-playground+meltdesc.c \
 -o meltbuild-sources/xtramelt-ana-simple+meltdesc.c -ot meltbuild-sources/xtramelt-playground+meltdesc.c \
 -o meltbuild-sources/xtramelt-c-generator+meltdesc.c -ot meltbuild-sources/xtramelt-playground+meltdesc.c \
 -o meltbuild-sources/xtramelt-opengpu+meltdesc.c -ot meltbuild-sources/xtramelt-playground+meltdesc.c \
 ]; then
      meltbuild_info melt-build-script.tpl:577/616 emit application C code for xtramelt-playground
      meltbuild_emit melt-build-script.tpl:578/617 \
	  translatefile \
	  xtramelt-playground \
	  meltbuild-sources \
	  meltbuild-modules \
	  warmelt-first.optimized:warmelt-base.optimized:warmelt-debug.optimized:warmelt-macro.optimized:warmelt-normal.optimized:warmelt-normatch.optimized:warmelt-genobj.optimized:warmelt-outobj.optimized:warmelt-hooks.optimized:warmelt-modes.optimized:xtramelt-ana-base.quicklybuilt:xtramelt-ana-tree.quicklybuilt:xtramelt-ana-gimple.quicklybuilt:xtramelt-probe.quicklybuilt:xtramelt-ana-simple.quicklybuilt:xtramelt-c-generator.quicklybuilt:xtramelt-opengpu.quicklybuilt \
    "" \
	  || meltbuild_error melt-build-script.tpl:585/618 failed to generate C code of application xtramelt-playground
  else
      meltbuild_info melt-build-script.tpl:587/619 DONT emit application C code for xtramelt-playground
  fi
  local meltapp_PLAYGROUND_cumulmd5=$(cat  meltbuild-sources/xtramelt-playground.c meltbuild-sources/xtramelt-playground+[0-9][0-9].c  | $MD5SUM | cut -b 1-32)
 
  if [ ! -f meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.quicklybuilt.so \
      -o meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.quicklybuilt.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-playground.c \
      -o  meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.quicklybuilt.so -ot  meltbuild-sources/xtramelt-playground+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/620 compiling application module for xtramelt-playground quicklybuilt
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/621 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=quicklybuilt \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-playground \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-playground \
	  || meltbuild_error  melt-build-script.tpl:604/622 in meltbuild-modules failed to compile application xtramelt-playground quicklybuilt "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/623 not compiling application module for xtramelt-playground quicklybuilt
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.optimized.so \
      -o meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.optimized.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-playground.c \
      -o  meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.optimized.so -ot  meltbuild-sources/xtramelt-playground+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/624 compiling application module for xtramelt-playground optimized
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/625 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=optimized \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-playground \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-playground \
	  || meltbuild_error  melt-build-script.tpl:604/626 in meltbuild-modules failed to compile application xtramelt-playground optimized "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/627 not compiling application module for xtramelt-playground optimized
  fi
 
  if [ ! -f meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.debugnoline.so \
      -o meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.debugnoline.so -ot  meltbuild-final-translator.stamp \
      -o  meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-playground.c \
      -o  meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.debugnoline.so -ot  meltbuild-sources/xtramelt-playground+meltdesc.c ]; then
      meltbuild_info melt-build-script.tpl:595/628 compiling application module for xtramelt-playground debugnoline
      $GCCMELT_MAKE -f $GCCMELT_MODULE_MK melt_module \
	  GCCMELT_FROM=melt-build-script.tpl:597/629 \
	  GCCMELT_MODULE_WORKSPACE=meltbuild-workdir \
	  GCCMELT_MODULE_FLAVOR=debugnoline \
	  GCCMELT_COMPILER="$GCCMELT_COMPILER" \
	  GCCMELT_CFLAGS="$GCCMELT_COMPILER_FLAGS" \
	  GCCMELT_MODULE_SOURCEBASE=meltbuild-sources/xtramelt-playground \
	  GCCMELT_MODULE_BINARYBASE=meltbuild-modules/xtramelt-playground \
	  || meltbuild_error  melt-build-script.tpl:604/630 in meltbuild-modules failed to compile application xtramelt-playground debugnoline "($GCCMELT_MAKE -f $GCCMELT_MODULE_MK)" compiler $GCCMELT_COMPILER_FLAGS cflags $GCCMELT_COMPILER_FLAGS
  else
      meltbuild_info melt-build-script.tpl:606/631 not compiling application module for xtramelt-playground debugnoline
  fi
 

  ## meltbuild_do_applications  melt-build-script.tpl:610/632
  local meltappstamptemp=$melt_final_application_stamp-tmp$$
  echo "///MELT application time stamp $melt_final_application_stamp" > $meltappstamptemp
  echo $GCCMELT_RUNTIME_DEPENDENCY_MD5SUM $GCCMELT_RUNTIME_DEPENDENCY >>  $meltappstamptemp

  $MD5SUM meltbuild-sources/xtramelt-ana-base.melt >>  $meltappstamptemp
  $MD5SUM meltbuild-sources/xtramelt-ana-base.c meltbuild-sources/xtramelt-ana-base+[0-9][0-9].c  >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.quicklybuilt.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.optimized.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-base.meltmod-$meltapp_ANA_BASE_cumulmd5.debugnoline.so >> $meltappstamptemp
 

  $MD5SUM meltbuild-sources/xtramelt-ana-tree.melt >>  $meltappstamptemp
  $MD5SUM meltbuild-sources/xtramelt-ana-tree.c meltbuild-sources/xtramelt-ana-tree+[0-9][0-9].c  >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.quicklybuilt.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.optimized.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-tree.meltmod-$meltapp_ANA_TREE_cumulmd5.debugnoline.so >> $meltappstamptemp
 

  $MD5SUM meltbuild-sources/xtramelt-ana-gimple.melt >>  $meltappstamptemp
  $MD5SUM meltbuild-sources/xtramelt-ana-gimple.c meltbuild-sources/xtramelt-ana-gimple+[0-9][0-9].c  >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.quicklybuilt.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.optimized.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-gimple.meltmod-$meltapp_ANA_GIMPLE_cumulmd5.debugnoline.so >> $meltappstamptemp
 

  $MD5SUM meltbuild-sources/xtramelt-probe.melt >>  $meltappstamptemp
  $MD5SUM meltbuild-sources/xtramelt-probe.c meltbuild-sources/xtramelt-probe+[0-9][0-9].c  >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.quicklybuilt.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.optimized.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-probe.meltmod-$meltapp_PROBE_cumulmd5.debugnoline.so >> $meltappstamptemp
 

  $MD5SUM meltbuild-sources/xtramelt-ana-simple.melt >>  $meltappstamptemp
  $MD5SUM meltbuild-sources/xtramelt-ana-simple.c meltbuild-sources/xtramelt-ana-simple+[0-9][0-9].c  >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.quicklybuilt.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.optimized.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-ana-simple.meltmod-$meltapp_ANA_SIMPLE_cumulmd5.debugnoline.so >> $meltappstamptemp
 

  $MD5SUM meltbuild-sources/xtramelt-c-generator.melt >>  $meltappstamptemp
  $MD5SUM meltbuild-sources/xtramelt-c-generator.c meltbuild-sources/xtramelt-c-generator+[0-9][0-9].c  >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.quicklybuilt.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.optimized.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-c-generator.meltmod-$meltapp_C_GENERATOR_cumulmd5.debugnoline.so >> $meltappstamptemp
 

  $MD5SUM meltbuild-sources/xtramelt-opengpu.melt >>  $meltappstamptemp
  $MD5SUM meltbuild-sources/xtramelt-opengpu.c meltbuild-sources/xtramelt-opengpu+[0-9][0-9].c  >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.quicklybuilt.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.optimized.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-opengpu.meltmod-$meltapp_OPENGPU_cumulmd5.debugnoline.so >> $meltappstamptemp
 

  $MD5SUM meltbuild-sources/xtramelt-playground.melt >>  $meltappstamptemp
  $MD5SUM meltbuild-sources/xtramelt-playground.c meltbuild-sources/xtramelt-playground+[0-9][0-9].c  >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.quicklybuilt.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.optimized.so >> $meltappstamptemp
 
  $MD5SUM meltbuild-modules/xtramelt-playground.meltmod-$meltapp_PLAYGROUND_cumulmd5.debugnoline.so >> $meltappstamptemp
 

  echo "///end stamp $melt_final_application_stamp"  >> $meltappstamptemp
  $GCCMELT_MOVE_IF_CHANGE $meltappstamptemp  $melt_final_application_stamp
meltbuild_info melt-build-script.tpl:623/633 times after applications at `date '+%x %H:%M:%S'`: ;  times >&2
} ## end meltbuild_do_applications  melt-build-script.tpl:624/634

if [ ! -f  "$melt_final_application_stamp" \
     -o "$melt_final_application_stamp" -ot "$melt_final_translator_stamp" \
 -o "$melt_final_application_stamp" -ot "$GCCMELT_MELTSOURCEDIR/xtramelt-ana-base.melt" \
 -o "$melt_final_application_stamp" -ot "$GCCMELT_MELTSOURCEDIR/xtramelt-ana-tree.melt" \
 -o "$melt_final_application_stamp" -ot "$GCCMELT_MELTSOURCEDIR/xtramelt-ana-gimple.melt" \
 -o "$melt_final_application_stamp" -ot "$GCCMELT_MELTSOURCEDIR/xtramelt-probe.melt" \
 -o "$melt_final_application_stamp" -ot "$GCCMELT_MELTSOURCEDIR/xtramelt-ana-simple.melt" \
 -o "$melt_final_application_stamp" -ot "$GCCMELT_MELTSOURCEDIR/xtramelt-c-generator.melt" \
 -o "$melt_final_application_stamp" -ot "$GCCMELT_MELTSOURCEDIR/xtramelt-opengpu.melt" \
 -o "$melt_final_application_stamp" -ot "$GCCMELT_MELTSOURCEDIR/xtramelt-playground.melt" \
 ]; then
    meltbuild_info melt-build-script.tpl:630/635 building MELT applications
    meltbuild_do_applications
else
    meltbuild_info melt-build-script.tpl:633/636 not building MELT applications because of applstamp  "$melt_final_application_stamp"
fi

################################################################
#@ melt-build-script.tpl:637/637
if [ "$melt_overall_goal" = "applications" ]; then
    meltbuild_info melt-build-script.tpl:639/638 done applications overall goal with stamp  $melt_final_translator_stamp
    meltbuild_notice 'Done applications' melt-build-script.tpl:640/639 applications overall goal 
    exit 0
fi
################################################################
################################################################
### the modules lists melt-build-script.tpl:645/640

if [ ! -f "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.quicklybuilt.modlis" \
    -o "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.quicklybuilt.modlis" -ot $melt_final_translator_stamp \
    -o "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.quicklybuilt.modlis" -ot $melt_final_application_stamp ]; then
  #  melt-build-script.tpl:650/641 module list quicklybuilt
  meltbuild_info  melt-build-script.tpl:651/642 generating module list  "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.quicklybuilt.modlis"
  melt_modlis_temp="meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.quicklybuilt.modlis-tmp$$"
  echo "# MELT module list file $MELTGCCBUILTIN_DEFAULT_MODLIS.quicklybuilt.modlis" >> $melt_modlis_temp
  echo "# MELT translator modules:" >> $melt_modlis_temp
  
  echo warmelt-first.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-base.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-debug.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-macro.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-normal.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-normatch.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-genobj.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-outobj.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-hooks.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-modes.quicklybuilt >> $melt_modlis_temp
 
  #@  melt-build-script.tpl:658/643
  echo "# MELT application modules:" >> $melt_modlis_temp
 
  echo xtramelt-ana-base.quicklybuilt >> $melt_modlis_temp
 
  echo xtramelt-ana-tree.quicklybuilt >> $melt_modlis_temp
 
  echo xtramelt-ana-gimple.quicklybuilt >> $melt_modlis_temp
 
  echo xtramelt-probe.quicklybuilt >> $melt_modlis_temp
 
  echo xtramelt-ana-simple.quicklybuilt >> $melt_modlis_temp
 
  echo xtramelt-c-generator.quicklybuilt >> $melt_modlis_temp
 
  echo xtramelt-opengpu.quicklybuilt >> $melt_modlis_temp
 
  echo xtramelt-playground.quicklybuilt >> $melt_modlis_temp
 
  $GCCMELT_MOVE_IF_CHANGE $melt_modlis_temp  "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.quicklybuilt.modlis"
  #  melt-build-script.tpl:664/644 warmelt module list quicklybuilt
  melt_modlis_temp="meltbuild-sources/warmelt.quicklybuilt.modlis-tmp$$"
  echo "# MELT translator modules:" >> $melt_modlis_temp
  
  echo warmelt-first.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-base.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-debug.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-macro.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-normal.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-normatch.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-genobj.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-outobj.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-hooks.quicklybuilt >> $melt_modlis_temp
  
  echo warmelt-modes.quicklybuilt >> $melt_modlis_temp
 
  $GCCMELT_MOVE_IF_CHANGE $melt_modlis_temp  "meltbuild-sources/warmelt.quicklybuilt.modlis"
else
  meltbuild_info  melt-build-script.tpl:672/645 keeping module list  "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.quicklybuilt.modlis"  
fi

if [ ! -f "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.optimized.modlis" \
    -o "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.optimized.modlis" -ot $melt_final_translator_stamp \
    -o "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.optimized.modlis" -ot $melt_final_application_stamp ]; then
  #  melt-build-script.tpl:650/646 module list optimized
  meltbuild_info  melt-build-script.tpl:651/647 generating module list  "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.optimized.modlis"
  melt_modlis_temp="meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.optimized.modlis-tmp$$"
  echo "# MELT module list file $MELTGCCBUILTIN_DEFAULT_MODLIS.optimized.modlis" >> $melt_modlis_temp
  echo "# MELT translator modules:" >> $melt_modlis_temp
  
  echo warmelt-first.optimized >> $melt_modlis_temp
  
  echo warmelt-base.optimized >> $melt_modlis_temp
  
  echo warmelt-debug.optimized >> $melt_modlis_temp
  
  echo warmelt-macro.optimized >> $melt_modlis_temp
  
  echo warmelt-normal.optimized >> $melt_modlis_temp
  
  echo warmelt-normatch.optimized >> $melt_modlis_temp
  
  echo warmelt-genobj.optimized >> $melt_modlis_temp
  
  echo warmelt-outobj.optimized >> $melt_modlis_temp
  
  echo warmelt-hooks.optimized >> $melt_modlis_temp
  
  echo warmelt-modes.optimized >> $melt_modlis_temp
 
  #@  melt-build-script.tpl:658/648
  echo "# MELT application modules:" >> $melt_modlis_temp
 
  echo xtramelt-ana-base.optimized >> $melt_modlis_temp
 
  echo xtramelt-ana-tree.optimized >> $melt_modlis_temp
 
  echo xtramelt-ana-gimple.optimized >> $melt_modlis_temp
 
  echo xtramelt-probe.optimized >> $melt_modlis_temp
 
  echo xtramelt-ana-simple.optimized >> $melt_modlis_temp
 
  echo xtramelt-c-generator.optimized >> $melt_modlis_temp
 
  echo xtramelt-opengpu.optimized >> $melt_modlis_temp
 
  echo xtramelt-playground.optimized >> $melt_modlis_temp
 
  $GCCMELT_MOVE_IF_CHANGE $melt_modlis_temp  "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.optimized.modlis"
  #  melt-build-script.tpl:664/649 warmelt module list optimized
  melt_modlis_temp="meltbuild-sources/warmelt.optimized.modlis-tmp$$"
  echo "# MELT translator modules:" >> $melt_modlis_temp
  
  echo warmelt-first.optimized >> $melt_modlis_temp
  
  echo warmelt-base.optimized >> $melt_modlis_temp
  
  echo warmelt-debug.optimized >> $melt_modlis_temp
  
  echo warmelt-macro.optimized >> $melt_modlis_temp
  
  echo warmelt-normal.optimized >> $melt_modlis_temp
  
  echo warmelt-normatch.optimized >> $melt_modlis_temp
  
  echo warmelt-genobj.optimized >> $melt_modlis_temp
  
  echo warmelt-outobj.optimized >> $melt_modlis_temp
  
  echo warmelt-hooks.optimized >> $melt_modlis_temp
  
  echo warmelt-modes.optimized >> $melt_modlis_temp
 
  $GCCMELT_MOVE_IF_CHANGE $melt_modlis_temp  "meltbuild-sources/warmelt.optimized.modlis"
else
  meltbuild_info  melt-build-script.tpl:672/650 keeping module list  "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.optimized.modlis"  
fi

if [ ! -f "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.debugnoline.modlis" \
    -o "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.debugnoline.modlis" -ot $melt_final_translator_stamp \
    -o "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.debugnoline.modlis" -ot $melt_final_application_stamp ]; then
  #  melt-build-script.tpl:650/651 module list debugnoline
  meltbuild_info  melt-build-script.tpl:651/652 generating module list  "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.debugnoline.modlis"
  melt_modlis_temp="meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.debugnoline.modlis-tmp$$"
  echo "# MELT module list file $MELTGCCBUILTIN_DEFAULT_MODLIS.debugnoline.modlis" >> $melt_modlis_temp
  echo "# MELT translator modules:" >> $melt_modlis_temp
  
  echo warmelt-first.debugnoline >> $melt_modlis_temp
  
  echo warmelt-base.debugnoline >> $melt_modlis_temp
  
  echo warmelt-debug.debugnoline >> $melt_modlis_temp
  
  echo warmelt-macro.debugnoline >> $melt_modlis_temp
  
  echo warmelt-normal.debugnoline >> $melt_modlis_temp
  
  echo warmelt-normatch.debugnoline >> $melt_modlis_temp
  
  echo warmelt-genobj.debugnoline >> $melt_modlis_temp
  
  echo warmelt-outobj.debugnoline >> $melt_modlis_temp
  
  echo warmelt-hooks.debugnoline >> $melt_modlis_temp
  
  echo warmelt-modes.debugnoline >> $melt_modlis_temp
 
  #@  melt-build-script.tpl:658/653
  echo "# MELT application modules:" >> $melt_modlis_temp
 
  echo xtramelt-ana-base.debugnoline >> $melt_modlis_temp
 
  echo xtramelt-ana-tree.debugnoline >> $melt_modlis_temp
 
  echo xtramelt-ana-gimple.debugnoline >> $melt_modlis_temp
 
  echo xtramelt-probe.debugnoline >> $melt_modlis_temp
 
  echo xtramelt-ana-simple.debugnoline >> $melt_modlis_temp
 
  echo xtramelt-c-generator.debugnoline >> $melt_modlis_temp
 
  echo xtramelt-opengpu.debugnoline >> $melt_modlis_temp
 
  echo xtramelt-playground.debugnoline >> $melt_modlis_temp
 
  $GCCMELT_MOVE_IF_CHANGE $melt_modlis_temp  "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.debugnoline.modlis"
  #  melt-build-script.tpl:664/654 warmelt module list debugnoline
  melt_modlis_temp="meltbuild-sources/warmelt.debugnoline.modlis-tmp$$"
  echo "# MELT translator modules:" >> $melt_modlis_temp
  
  echo warmelt-first.debugnoline >> $melt_modlis_temp
  
  echo warmelt-base.debugnoline >> $melt_modlis_temp
  
  echo warmelt-debug.debugnoline >> $melt_modlis_temp
  
  echo warmelt-macro.debugnoline >> $melt_modlis_temp
  
  echo warmelt-normal.debugnoline >> $melt_modlis_temp
  
  echo warmelt-normatch.debugnoline >> $melt_modlis_temp
  
  echo warmelt-genobj.debugnoline >> $melt_modlis_temp
  
  echo warmelt-outobj.debugnoline >> $melt_modlis_temp
  
  echo warmelt-hooks.debugnoline >> $melt_modlis_temp
  
  echo warmelt-modes.debugnoline >> $melt_modlis_temp
 
  $GCCMELT_MOVE_IF_CHANGE $melt_modlis_temp  "meltbuild-sources/warmelt.debugnoline.modlis"
else
  meltbuild_info  melt-build-script.tpl:672/655 keeping module list  "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.debugnoline.modlis"  
fi


#@ melt-build-script.tpl:676/656
if [ ! -f "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.modlis" ]; then
   meltbuild_symlink "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.optimized.modlis" "meltbuild-sources/$MELTGCCBUILTIN_DEFAULT_MODLIS.modlis"
fi

################################################################
#@ melt-build-script.tpl:682/657 module lists
if [ "$melt_overall_goal" = "modlists" ]; then
    meltbuild_info melt-build-script.tpl:684/658 done modlists overall goal with stamp  $melt_final_application_stamp
    exit 0
fi


################################################################
#@ melt-build-script.tpl:690/659 making the meltbuild-common.args file to make life easier
# I would often use that meltbuild-common.args for testing, etc.
meltcommon_args=meltbuild-common.args
meltbuild_info melt-build-script.tpl:693/660 making $meltcommon_args
meltcommon_argstemp=$meltcommon_args-tmp$$
echo ' -DGCCMELT_FROM_ARG="melt-build-script.tpl:695/661"' > $meltcommon_argstemp
meltbuild_arg workdir=meltbuild-workdir >>  $meltcommon_argstemp
meltbuild_arg tempdir=meltbuild-tempdir >> $meltcommon_argstemp
meltbuild_arg source-path=meltbuild-sources:$GCCMELT_LASTSTAGE >> $meltcommon_argstemp
meltbuild_arg module-path=meltbuild-modules:$GCCMELT_LASTSTAGE >> $meltcommon_argstemp
meltbuild_arg "module-cflags=\"$GCCMELT_COMPILER_FLAGS\"" >> $meltcommon_argstemp
meltbuild_arg "module-makefile=\"$GCCMELT_MODULE_MK\""  >>  $meltcommon_argstemp

$GCCMELT_MOVE_IF_CHANGE $meltcommon_argstemp $meltcommon_args
meltbuild_info melt-build-script.tpl:704/662 $meltcommon_args is
cat $meltcommon_args < /dev/null >&2




################################################################
#@ melt-build-script.tpl:711/663 runtime self check

##  melt-build-script.tpl:713/664 FIXME: should skip that when cross-compiler MELT plugin..

meltcheckruntime_stamp=meltbuild-checkruntime.stamp
if [ ! -f $meltcheckruntime_stamp -o $meltcheckruntime_stamp -ot "$GCCMELT_RUNTIME_ARGS" \
    -o $meltcheckruntime_stamp -ot "$GCCMELT_RUNTIME_C" \
    -o $meltcheckruntime_stamp -ot $melt_final_application_stamp ]; then
    #@ melt-build-script.tpl:719/665 checkruntime
    if [ -f melt-no-check-runtime -o -n "$MELTGCC_NO_CHECK_RUNTIME" -o ! -f melt-runtime.i ]; then
	meltbuild_info melt-build-script.tpl:721/666 skipping check of MELT runtime
    else
	meltcheckruntime_args=meltbuild-checkruntime.args 
	meltcheckruntime_argstemp=$meltcheckruntime_args-tmp$$
	echo ' -DGCCMELT_FROM_ARG="melt-build-script.tpl:725/667"' > $meltcheckruntime_argstemp
	meltbuild_arg mode=meltframe >> $meltcheckruntime_argstemp
	meltbuild_arg workdir=meltbuild-workdir >>  $meltcheckruntime_argstemp
	meltbuild_arg tempdir=meltbuild-tempdir >> $meltcheckruntime_argstemp
	meltbuild_arg source-path=meltbuild-sources >> $meltcheckruntime_argstemp
	meltbuild_arg module-path=meltbuild-modules >> $meltcheckruntime_argstemp
	meltbuild_arg "module-cflags=\"$GCCMELT_COMPILER_FLAGS\"" >> $meltcheckruntime_argstemp
	meltbuild_arg bootstrapping  >> $meltcheckruntime_argstemp
	echo ' -o /dev/null' >> $meltcheckruntime_argstemp
	echo melt-runtime.i >> $meltcheckruntime_argstemp
	$GCCMELT_MOVE_IF_CHANGE  $meltcheckruntime_argstemp $meltcheckruntime_args
	[ -f "$meltcheckruntime_args" ] || meltbuild_error  melt-build-script.tpl:736/668 missing check runtime args  "$meltcheckruntime_args"
	meltbuild_info melt-build-script.tpl:737/669 $meltcheckruntime_args  is
	cat $meltcheckruntime_args < /dev/null >&2
	if [ -n "$MELTGCCBUILTIN_BUILD_WITH_CXX" ]; then
	    $GCCMELT_CC1_PREFIX $GCCMELT_CC1PLUS @$meltcheckruntime_args \
		|| meltbuild_error melt-build-script.tpl:741/670 failed  $GCCMELT_CC1PLUS with arguments @$meltcheckruntime_args
	else
	    $GCCMELT_CC1_PREFIX $GCCMELT_CC1 @$meltcheckruntime_args \
		|| meltbuild_error melt-build-script.tpl:744/671 failed  $GCCMELT_CC1 with arguments @$meltcheckruntime_args
	fi
	meltbuild_info melt-build-script.tpl:746/672 done check runtime with $meltcheckruntime_args
    fi

   #@ melt-build-script.tpl:749/673 checkhello
    meltcheckhelloworld_args=meltbuild-checkhelloworld.args 
    meltcheckhelloworld_argstemp=$meltcheckhelloworld_args-tmp$$
    echo ' -DGCCMELT_FROM_ARG="melt-build-script.tpl:752/674"' > $meltcheckhelloworld_argstemp
    meltbuild_arg mode=runfile >> $meltcheckhelloworld_argstemp
    meltbuild_arg workdir=meltbuild-workdir >>  $meltcheckhelloworld_argstemp
    meltbuild_arg module-makefile=$GCCMELT_MODULE_MK >>  $meltcheckhelloworld_argstemp
    meltbuild_arg tempdir=meltbuild-tempdir >> $meltcheckhelloworld_argstemp
    meltbuild_arg source-path=meltbuild-sources >> $meltcheckhelloworld_argstemp
    meltbuild_arg module-path=meltbuild-modules >> $meltcheckhelloworld_argstemp
    meltbuild_arg "module-cflags=\"$GCCMELT_COMPILER_FLAGS\"" >> $meltcheckhelloworld_argstemp
    date +'(code_chunk hello%j #{puts("hello world from MELT %F @" __TIME__"\n")}#)' > meltbuild-hello.melt-tmp$$
    $GCCMELT_MOVE_IF_CHANGE meltbuild-hello.melt-tmp$$  meltbuild-hello.melt
    meltbuild_arg arg=meltbuild-hello.melt >> $meltcheckhelloworld_argstemp
    echo ' meltbuild-empty-file.c -o /dev/null' >> $meltcheckhelloworld_argstemp
    cat $GCCMELT_HELLOWORLD_ARGS < /dev/null >>  $meltcheckhelloworld_argstemp
    $GCCMELT_MOVE_IF_CHANGE  $meltcheckhelloworld_argstemp $meltcheckhelloworld_args
    [ -f "$meltcheckhelloworld_args" ] || meltbuild_error  melt-build-script.tpl:766/675 missing check helloworld args  "$meltcheckhelloworld_args"
   meltbuild_info melt-build-script.tpl:767/676 $meltcheckhelloworld_args  is
   cat $meltcheckhelloworld_args < /dev/null >&2
    $GCCMELT_CC1_PREFIX $GCCMELT_CC1 @$meltcheckhelloworld_args \
	|| meltbuild_error melt-build-script.tpl:770/677 running helloworld failed with arguments @$meltcheckhelloworld_args
   meltbuild_info melt-build-script.tpl:771/678 done check helloworld with $meltcheckhelloworld_args
   #@ melt-build-script.tpl:772/679 runtime stamp
    meltcheckruntime_stamptemp=$meltcheckruntime_stamp-tmp$$
    [ -f "$GCCMELT_RUNTIME_C" ] || meltbuild_error melt-build-script.tpl:774/680 missing MELT runtime C file $GCCMELT_RUNTIME_C
    echo "/// MELT check runtime timestamp file $meltcheckruntime_stamp" > $meltcheckruntime_stamptemp
    echo $GCCMELT_RUNTIME_DEPENDENCY_MD5SUM $GCCMELT_RUNTIME_DEPENDENCY >> $meltcheckruntime_stamptemp
    $MD5SUM $GCCMELT_RUNTIME_C < /dev/null >>  $meltcheckruntime_stamptemp
    $MD5SUM meltbuild-hello.melt < /dev/null >>  $meltcheckruntime_stamptemp
    [ -f "$melt_final_translator_stamp" ] || meltbuild_error melt-build-script.tpl:779/681 missing final translator stamp "$melt_final_translator_stamp"
    [ -f "$melt_final_application_stamp" ] || meltbuild_error melt-build-script.tpl:780/682 missing final application stamp "$melt_final_application_stamp"
    grep meltbuild-modules/ "$melt_final_translator_stamp" "$melt_final_application_stamp" < /dev/null >>   $meltcheckruntime_stamptemp
    echo "///end timestamp file $meltcheckruntime_stamp" >>   $meltcheckruntime_stamptemp
    $GCCMELT_MOVE_IF_CHANGE  $meltcheckruntime_stamptemp $meltcheckruntime_stamp
    meltbuild_info melt-build-script.tpl:784/683 done check runtime  $meltcheckruntime_stamp
else
    meltbuild_info melt-build-script.tpl:786/684 keeping runtime checks  $meltcheckruntime_stamp
fi

if [ "$melt_overall_goal" = "checkruntime" ]; then
    meltbuild_info melt-build-script.tpl:790/685 done checkruntime overall goal with stamp  $meltcheckruntime_stamp
    exit 0
fi
################################################################
################################################################
#@ melt-build-script.tpl:795/686
if [ "$melt_overall_goal" = "regenerate" ]; then
    meltbuild_notice regenerating runtime support melt-build-script.tpl:797/687 
    [ -d meltbuild-sources/generated ] || mkdir meltbuild-sources/generated
    meltregen_args=meltbuild-regen.args
    meltregen_argstemp="$meltregen_args-tmp$$"
    echo ' -DGCCMELT_FROM_ARG="melt-build-script.tpl:801/688"' > $meltregen_argstemp
   meltbuild_arg mode=runtypesupport >> $meltregen_argstemp
    meltbuild_arg output=meltbuild-sources/generated/meltrunsup >> $meltregen_argstemp
    meltbuild_arg workdir=meltbuild-workdir >>  $meltregen_argstemp
    meltbuild_arg tempdir=meltbuild-tempdir >> $meltregen_argstemp
    meltbuild_arg source-path=meltbuild-sources >> $meltregen_argstemp
    meltbuild_arg module-path=meltbuild-modules >> $meltregen_argstemp
    meltbuild_arg bootstrapping  >> $meltregen_argstemp
    echo meltbuild-empty-file.c >> $meltregen_argstemp
    $GCCMELT_MOVE_IF_CHANGE  $meltregen_argstemp $meltregen_args
   meltbuild_info melt-build-script.tpl:811/689 $meltregen_args  is
   cat $meltregen_args < /dev/null >&2
    $GCCMELT_CC1_PREFIX $GCCMELT_CC1 @$meltregen_args \
	|| meltbuild_error melt-build-script.tpl:814/690 failed with arguments @$meltregen_args
    meltbuild_info melt-build-script.tpl:815/691 done regenerate overall goal
    exit 0
fi

################################################################
################################################################
### the generated documentation meltgendoc.texi melt-build-script.tpl:821/692

if [   ! -f meltgendoc.texi  -o meltbuild-sources/warmelt-first.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/warmelt-base.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/warmelt-debug.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/warmelt-macro.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/warmelt-normal.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/warmelt-normatch.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/warmelt-genobj.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/warmelt-outobj.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/warmelt-hooks.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/warmelt-modes.melt -nt meltgendoc.texi  \
  -o meltbuild-sources/xtramelt-ana-base.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/xtramelt-ana-tree.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/xtramelt-ana-gimple.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/xtramelt-probe.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/xtramelt-ana-simple.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/xtramelt-c-generator.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/xtramelt-opengpu.melt -nt meltgendoc.texi  \
 -o meltbuild-sources/xtramelt-playground.melt -nt meltgendoc.texi   ]; then
   meltbuild_info melt-build-script.tpl:825/693 generating meltgendoc.texi
   meltgen_args=meltbuild-gendoc.args-tmp$$
   echo ' -DGCCMELT_FROM_ARG="melt-build-script.tpl:827/694"' > $meltgen_args
   meltbuild_arg mode=makedoc >> $meltgen_args
   meltbuild_arg output=meltgendoc.texi >> $meltgen_args
   meltbuild_arg init=@$MELTGCCBUILTIN_DEFAULT_MODLIS.quicklybuilt >> $meltgen_args
   meltbuild_arg workdir=meltbuild-workdir >>  $meltgen_args
   meltbuild_arg tempdir=meltbuild-tempdir >> $meltgen_args
   meltbuild_arg source-path=meltbuild-sources >> $meltgen_args
   meltbuild_arg module-path=meltbuild-modules >> $meltgen_args
   meltbuild_arg bootstrapping  >> $meltgen_args 
   meltbuild_arg arglist=warmelt-first.melt,warmelt-base.melt,warmelt-debug.melt,warmelt-macro.melt,warmelt-normal.melt,warmelt-normatch.melt,warmelt-genobj.melt,warmelt-outobj.melt,warmelt-hooks.melt,warmelt-modes.melt,xtramelt-ana-base.melt,xtramelt-ana-tree.melt,xtramelt-ana-gimple.melt,xtramelt-probe.melt,xtramelt-ana-simple.melt,xtramelt-c-generator.melt,xtramelt-opengpu.melt,xtramelt-playground.melt  >> $meltgen_args 
   echo meltbuild-empty-file.c >> $meltgen_args
   $GCCMELT_MOVE_IF_CHANGE  $meltgen_args meltbuild-gendoc.args
   meltbuild_info melt-build-script.tpl:839/695  meltbuild-gendoc.args is
   cat meltbuild-gendoc.args < /dev/null >&2
   $GCCMELT_CC1_PREFIX $GCCMELT_CC1 @meltbuild-gendoc.args \
     || meltbuild_error melt-build-script.tpl:842/696 failed with arguments @meltbuild-gendoc.args
else
   meltbuild_info melt-build-script.tpl:844/697 keeping meltgendoc.texi
fi

################
meltbuild_info melt-build-script.tpl:848/698 successfully done with times at `date '+%x %H:%M:%S'`: ; times >&2

################################################################
#@ melt-build-script.tpl:851/699
if [ "$melt_overall_goal" = "gendoc" ]; then
    meltbuild_info melt-build-script.tpl:853/700 done gendoc overall goal with stamp  $melt_final_translator_stamp
    exit 0
fi

## #@ melt-build-script.tpl:857/701 if we get here something is wrong in this script
meltbuild_error  melt-build-script.tpl:858/702 unexpected MELT overall goal "$melt_overall_goal" buggy melt-build-script.tpl
#@ eof melt-build-script.tpl:859/703 end of generated melt-build-script.sh
